/**
  * Redistribution and use of this software and associated
  * documentation ("Software"), with or without modification, are
  * permitted provided that the following conditions are met:
  *
  * 1. Redistributions of source code must retain copyright statements
  *    and notices.  Redistributions must also contain a copy of this
  *    document.
  *
  * 2. Redistributions in binary form must reproduce the above
  *    copyright notice, this list of conditions and the following
  *    disclaimer in the documentation and/or other materials provided
  *    with the distribution.
  *
  * 3. The names "TRANSORG" or "EUTIST-AMI" must not be used to endorse or promote
  *    products derived from this Software without prior written
  *    permission of one of the parties involved in the TRANSORG project. For
  * 	  written permission, please contact diasz@ida.liu.se.
  *
  * 4. Products derived from this Software may not be called "TRANSORG"
  *    nor may "TRANSORG" appear in their names without prior written
  *    permission.
  *
  * 5. Due credit should be given to the TRANSORG Project
  *    (http://www.ida.liu.se/~rtslab/TRANSORG/).
  *
  * THIS SOFTWARE IS PROVIDED BY THE TRANSORG PROJECT CONTRIBUTORS ``AS IS'' AND
  * ANY EXPRESSED OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
  * THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A
  * PARTICULAR PURPOSE ARE DISCLAIMED.
  *
  * IN NO EVENT SHALL THE TRANSORG PROJECT CONTRIBUTORS
  * BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
  * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE
  * GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
  * CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
  * OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT
  * OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
  * SUCH DAMAGE.
  *
  * Copyright 2003 (C) TRANSORG Project Contributors All Rights Reserved.
  *
  * $Id: Constants.java,v 1.0   Exp $
  *
  */

/** Author		: Rahul Agarwal
* Modified		: Isabelle Ravot
* Last changed	: 23/08/02
* Contact		: diasz@ida.liu.se
*/

package universal;
/**
 *Define some constants
 */
public class Constants {

    /* General */
    public static final int MAX_STORE = 30;

    /**
     *The number maximal of replicated server
     */
    public static final int MAX_PROCESSES = 30;


    //Timeout after which the client resend the request
    //public static  long TIMEOUT = 100000;

    /**
     *Expiration time after which the request can be remove from the outcomeStore.
     */
    public static final long EXPIRATION_TIME=100000;

    /**
     *Number of request store in the outcomeStore after which check if some have expire.
     */
    public static final int NUMBER_REQUEST = 15;



    /**
     *The service context id can be choose randomly but shouldn't be equal to one
     */
    public static final int NUM_Service_Context=120;
    /* ObjectgramSocket */

    //	public static final int MAX_OBJECT_LENGTH = 65516;
    /**
     *Max length of packet receive
     */
	public static final int MAX_OBJECT_LENGTH = 30000;


	/* Sender */
    // public static final int RETRANSMIT_DELTA = 3000;
    //Finally not use because we don't need to retransmit the packet (we use a TCP soket which is reliable)
    	public static final int RETRANSMIT_DELTA = 7000;

    /* Leader */
    /**
     *Time interval to update the trust list and send amAlive messages
     */
    public static final int OMEGA_DELTA = 4000;
    /**
     * Initial maximum time interval to receive am alive message before suspecting a process to be crash.
     *  Adjusted if a process is incorrectly suspected
     */
    public static final int INITIAL_MAX_DELTA = 4500;

}
