/**
  * Redistribution and use of this software and associated
  * documentation ("Software"), with or without modification, are
  * permitted provided that the following conditions are met:
  *
  * 1. Redistributions of source code must retain copyright statements
  *    and notices.  Redistributions must also contain a copy of this
  *    document.
  *
  * 2. Redistributions in binary form must reproduce the above
  *    copyright notice, this list of conditions and the following
  *    disclaimer in the documentation and/or other materials provided
  *    with the distribution.
  *
  * 3. The names "TRANSORG" or "EUTIST-AMI" must not be used to endorse or promote
  *    products derived from this Software without prior written
  *    permission of one of the parties involved in the TRANSORG project. For
  * 	  written permission, please contact diasz@ida.liu.se.
  *
  * 4. Products derived from this Software may not be called "TRANSORG"
  *    nor may "TRANSORG" appear in their names without prior written
  *    permission.
  *
  * 5. Due credit should be given to the TRANSORG Project
  *    (http://www.ida.liu.se/~rtslab/TRANSORG/).
  *
  * THIS SOFTWARE IS PROVIDED BY THE TRANSORG PROJECT CONTRIBUTORS ``AS IS'' AND
  * ANY EXPRESSED OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
  * THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A
  * PARTICULAR PURPOSE ARE DISCLAIMED.
  *
  * IN NO EVENT SHALL THE TRANSORG PROJECT CONTRIBUTORS
  * BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
  * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE
  * GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
  * CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
  * OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT
  * OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
  * SUCH DAMAGE.
  *
  * Copyright 2003 (C) TRANSORG Project Contributors All Rights Reserved.
  *
  * $Id: MethTable.java,v 1.0  diasz Exp $
  *
  * Date         Author  Changes
  */

package universal;

/*
 * Author       : Isabelle Ravot
 * Date         : 01/08/02
 * Last changes : 01/08/02
 * Contact		: diasz@ida.liu.se
 */

import universal.*;
import java.util.*;

/**
 *This class should be complete by the application writer to store the information about
 *each method of the server.
 */
public class MethTable
{
    /**
     *Array of the size of the number of method our application implement.
     *
     */
    public universal.MethSignStr methods[]=new universal.MethSignStr[21];
    /**
     * Contains the definition of each method
     */
    public MethTable(org.omg.CORBA.ORB orb)
    {
	methods[0]=new universal.MethSignStr();
	methods[0].name="sum";
	methods[0].readMethod=false;

	methods[0].param_modes=new int[2];
	methods[0].param_modes[0]=org.omg.CORBA.ParameterMode._PARAM_IN;
	methods[0].param_modes[1]=org.omg.CORBA.ParameterMode._PARAM_IN;

	methods[0].param_types=new org.omg.CORBA.TypeCode[2];
	methods[0].param_types[0]=orb.get_primitive_tc(org.omg.CORBA.TCKind.tk_float);
	methods[0].param_types[1]=orb.get_primitive_tc(org.omg.CORBA.TCKind.tk_float);

	methods[1]=new universal.MethSignStr();

	methods[1].name="testLong";
	methods[1].readMethod=false;

	methods[1].param_modes=new int[3];

	methods[1].param_modes[0]=org.omg.CORBA.ParameterMode._PARAM_IN;
	methods[1].param_modes[1]=org.omg.CORBA.ParameterMode._PARAM_INOUT;
	methods[1].param_modes[2]=org.omg.CORBA.ParameterMode._PARAM_OUT;

	methods[1].param_types=new org.omg.CORBA.TypeCode[3];
	methods[1].param_types[0]=orb.get_primitive_tc(org.omg.CORBA.TCKind.tk_long);
	methods[1].param_types[1]=orb.get_primitive_tc(org.omg.CORBA.TCKind.tk_long);
	methods[1].param_types[2]=orb.get_primitive_tc(org.omg.CORBA.TCKind.tk_long);
	//Definition of the method of the trivial application
	//m1
	methods[2]=new universal.MethSignStr();
	methods[2].name="m1";
	methods[2].readMethod=false;

	methods[2].param_modes=new int[6];
	methods[2].param_modes[0]=org.omg.CORBA.ParameterMode._PARAM_IN;
	methods[2].param_modes[1]=org.omg.CORBA.ParameterMode._PARAM_IN;
	methods[2].param_modes[2]=org.omg.CORBA.ParameterMode._PARAM_IN;
	methods[2].param_modes[3]=org.omg.CORBA.ParameterMode._PARAM_INOUT;
	methods[2].param_modes[4]=org.omg.CORBA.ParameterMode._PARAM_OUT;
	methods[2].param_modes[5]=org.omg.CORBA.ParameterMode._PARAM_INOUT;


	methods[2].param_types=new org.omg.CORBA.TypeCode[6];
	methods[2].param_types[0]=orb.get_primitive_tc(org.omg.CORBA.TCKind.tk_long);
	methods[2].param_types[1]=orb.get_primitive_tc(org.omg.CORBA.TCKind.tk_string);
	methods[2].param_types[2]=orb.get_primitive_tc(org.omg.CORBA.TCKind.tk_boolean);
	methods[2].param_types[3]=orb.get_primitive_tc(org.omg.CORBA.TCKind.tk_char);
	methods[2].param_types[4]=orb.get_primitive_tc(org.omg.CORBA.TCKind.tk_double);
	methods[2].param_types[5]=orb.get_primitive_tc(org.omg.CORBA.TCKind.tk_short);

	//m2
	methods[3]=new universal.MethSignStr();
	methods[3].name="m2";
	methods[3].readMethod=false;

	methods[3].param_modes=new int[2];
	methods[3].param_modes[0]=org.omg.CORBA.ParameterMode._PARAM_IN;
	methods[3].param_modes[1]=org.omg.CORBA.ParameterMode._PARAM_IN;

	methods[3].param_types=new org.omg.CORBA.TypeCode[2];
	methods[3].param_types[0]=orb.get_primitive_tc(org.omg.CORBA.TCKind.tk_long);
	methods[3].param_types[1]=orb.get_primitive_tc(org.omg.CORBA.TCKind.tk_boolean);

	//m3
	methods[4]=new universal.MethSignStr();
	methods[4].name="m3";
	methods[4].readMethod=true;

	methods[4].param_modes=new int[0];


	methods[4].param_types=new org.omg.CORBA.TypeCode[0];


	//m4
	methods[5]=new universal.MethSignStr();
	methods[5].name="m4";
	methods[5].readMethod=true;

	methods[5].param_modes=new int[0];


	methods[5].param_types=new org.omg.CORBA.TypeCode[0];

	//create job
	methods[6]=new universal.MethSignStr();
	methods[6].name="create_job";
	methods[6].readMethod=false;

	methods[6].param_modes=new int[4];
	methods[6].param_modes[0]=org.omg.CORBA.ParameterMode._PARAM_IN;
	methods[6].param_modes[1]=org.omg.CORBA.ParameterMode._PARAM_IN;
	methods[6].param_modes[2]=org.omg.CORBA.ParameterMode._PARAM_IN;
	methods[6].param_modes[3]=org.omg.CORBA.ParameterMode._PARAM_IN;

	methods[6].param_types=new org.omg.CORBA.TypeCode[4];
	methods[6].param_types[0]=orb.get_primitive_tc(org.omg.CORBA.TCKind.tk_string);
	methods[6].param_types[1]=com.ericsson.nms.cif.am.ActivityManager.EvaluationPolicyHelper.type();
	methods[6].param_types[2]=com.ericsson.nms.cif.am.ActivityManager.TimeOutDurationHelper.type();
	methods[6].param_types[3]=orb.get_primitive_tc(org.omg.CORBA.TCKind.tk_string);


	//create job with termination IOR
	methods[7]=new universal.MethSignStr();
	methods[7].name="create_job_with_termination_IOR";
	methods[7].readMethod=false;

	methods[7].param_modes=new int[5];
	methods[7].param_modes[0]=org.omg.CORBA.ParameterMode._PARAM_IN;
	methods[7].param_modes[1]=org.omg.CORBA.ParameterMode._PARAM_IN;
	methods[7].param_modes[2]=org.omg.CORBA.ParameterMode._PARAM_IN;
	methods[7].param_modes[3]=org.omg.CORBA.ParameterMode._PARAM_IN;
	methods[7].param_modes[4]=org.omg.CORBA.ParameterMode._PARAM_IN;

	methods[7].param_types=new org.omg.CORBA.TypeCode[5];
	methods[7].param_types[0]=orb.get_primitive_tc(org.omg.CORBA.TCKind.tk_string);
	methods[7].param_types[1]=com.ericsson.nms.cif.am.ActivityManager.EvaluationPolicyHelper.type();
	methods[7].param_types[2]=com.ericsson.nms.cif.am.ActivityManager.TimeOutDurationHelper.type();
	methods[7].param_types[3]=orb.get_primitive_tc(org.omg.CORBA.TCKind.tk_string);
	methods[7].param_types[4]=orb.get_primitive_tc(org.omg.CORBA.TCKind.tk_string);

	//create immediate activity
	methods[8]=new universal.MethSignStr();
	methods[8].name="create_immediate_activity";
	methods[8].readMethod=false;

	methods[8].param_modes=new int[4];
	methods[8].param_modes[0]=org.omg.CORBA.ParameterMode._PARAM_IN;
	methods[8].param_modes[1]=org.omg.CORBA.ParameterMode._PARAM_IN;
	methods[8].param_modes[2]=org.omg.CORBA.ParameterMode._PARAM_IN;
	methods[8].param_modes[3]=org.omg.CORBA.ParameterMode._PARAM_IN;


	methods[8].param_types=new org.omg.CORBA.TypeCode[4];
	methods[8].param_types[0]=orb.get_primitive_tc(org.omg.CORBA.TCKind.tk_longlong);
	methods[8].param_types[1]=com.ericsson.nms.cif.am.ActivityManager.ActivityObjectHelper.type();
	methods[8].param_types[2]=com.ericsson.nms.cif.am.ActivityManager.TimeOutDurationHelper.type();
	methods[8].param_types[3]=orb.get_primitive_tc(org.omg.CORBA.TCKind.tk_string);

	//create periodic activity

	methods[9]=new universal.MethSignStr();
	methods[9].name="create_periodic_activity";
	methods[9].readMethod=false;

	methods[9].param_modes=new int[5];
	methods[9].param_modes[0]=org.omg.CORBA.ParameterMode._PARAM_IN;
	methods[9].param_modes[1]=org.omg.CORBA.ParameterMode._PARAM_IN;
	methods[9].param_modes[2]=org.omg.CORBA.ParameterMode._PARAM_IN;
	methods[9].param_modes[3]=org.omg.CORBA.ParameterMode._PARAM_IN;
	methods[9].param_modes[4]=org.omg.CORBA.ParameterMode._PARAM_IN;


	methods[9].param_types=new org.omg.CORBA.TypeCode[5];
	methods[9].param_types[0]=orb.get_primitive_tc(org.omg.CORBA.TCKind.tk_longlong);
	methods[9].param_types[1]=com.ericsson.nms.cif.am.ActivityManager.ActivityObjectHelper.type();
	methods[9].param_types[2]=com.ericsson.nms.cif.am.ActivityManager.WeekMaskSeqHelper.type();
	methods[9].param_types[3]=com.ericsson.nms.cif.am.ActivityManager.TimeOutDurationHelper.type();
	methods[9].param_types[4]=orb.get_primitive_tc(org.omg.CORBA.TCKind.tk_string);


	//create relative activity
	methods[10]=new universal.MethSignStr();
	methods[10].name="create_relative_activity";
	methods[10].readMethod=false;

	methods[10].param_modes=new int[7];
	methods[10].param_modes[0]=org.omg.CORBA.ParameterMode._PARAM_IN;
	methods[10].param_modes[1]=org.omg.CORBA.ParameterMode._PARAM_IN;
	methods[10].param_modes[2]=org.omg.CORBA.ParameterMode._PARAM_IN;
	methods[10].param_modes[3]=org.omg.CORBA.ParameterMode._PARAM_IN;
	methods[10].param_modes[4]=org.omg.CORBA.ParameterMode._PARAM_IN;
	methods[10].param_modes[5]=org.omg.CORBA.ParameterMode._PARAM_IN;
	methods[10].param_modes[6]=org.omg.CORBA.ParameterMode._PARAM_IN;


	methods[10].param_types=new org.omg.CORBA.TypeCode[7];
	methods[10].param_types[0]=orb.get_primitive_tc(org.omg.CORBA.TCKind.tk_longlong);
	methods[10].param_types[1]=com.ericsson.nms.cif.am.ActivityManager.ActivityObjectHelper.type();
	methods[10].param_types[2]=com.ericsson.nms.cif.am.ActivityManager.ActivityRelationHelper.type();
	methods[10].param_types[3]=org.omg.CORBA.LongLongSeqHelper.type();
	methods[10].param_types[4]=orb.get_primitive_tc(org.omg.CORBA.TCKind.tk_longlong);
	methods[10].param_types[5]=com.ericsson.nms.cif.am.ActivityManager.TimeOutDurationHelper.type();
	methods[10].param_types[6]=orb.get_primitive_tc(org.omg.CORBA.TCKind.tk_string);

	//copy job
	methods[11]=new universal.MethSignStr();
	methods[11].name="copy_job";
	methods[11].readMethod=false;

	methods[11].param_modes=new int[3];
	methods[11].param_modes[0]=org.omg.CORBA.ParameterMode._PARAM_IN;
	methods[11].param_modes[1]=org.omg.CORBA.ParameterMode._PARAM_IN;
	methods[11].param_modes[2]=org.omg.CORBA.ParameterMode._PARAM_IN;

	methods[11].param_types=new org.omg.CORBA.TypeCode[3];
	methods[11].param_types[0]=orb.get_primitive_tc(org.omg.CORBA.TCKind.tk_longlong);
	methods[11].param_types[1]=orb.get_primitive_tc(org.omg.CORBA.TCKind.tk_string);
	methods[11].param_types[2]=orb.get_primitive_tc(org.omg.CORBA.TCKind.tk_string);


	//start job
	methods[12]=new universal.MethSignStr();
	methods[12].name="start_job";
	methods[12].readMethod=false;

	methods[12].param_modes=new int[2];
	methods[12].param_modes[0]=org.omg.CORBA.ParameterMode._PARAM_IN;
	methods[12].param_modes[1]=org.omg.CORBA.ParameterMode._PARAM_IN;

	methods[12].param_types=new org.omg.CORBA.TypeCode[2];
	methods[12].param_types[0]=orb.get_primitive_tc(org.omg.CORBA.TCKind.tk_longlong);
	methods[12].param_types[1]=orb.get_primitive_tc(org.omg.CORBA.TCKind.tk_string);

	//schedule job
	methods[13]=new universal.MethSignStr();
	methods[13].name="schedule_job";
	methods[13].readMethod=false;

	methods[13].param_modes=new int[3];
	methods[13].param_modes[0]=org.omg.CORBA.ParameterMode._PARAM_IN;
	methods[13].param_modes[1]=org.omg.CORBA.ParameterMode._PARAM_IN;
	methods[13].param_modes[2]=org.omg.CORBA.ParameterMode._PARAM_IN;

	methods[13].param_types=new org.omg.CORBA.TypeCode[3];
	methods[13].param_types[0]=orb.get_primitive_tc(org.omg.CORBA.TCKind.tk_longlong);
	methods[13].param_types[1]=com.ericsson.nms.cif.am.ActivityManager.DayTime24Helper.type();
	methods[13].param_types[2]=orb.get_primitive_tc(org.omg.CORBA.TCKind.tk_string);


	//get jobs
	methods[14]=new universal.MethSignStr();
	methods[14].name="get_jobs";
	methods[14].readMethod=false;

	methods[14].param_modes=new int[2];
	methods[14].param_modes[0]=org.omg.CORBA.ParameterMode._PARAM_IN;
	methods[14].param_modes[1]=org.omg.CORBA.ParameterMode._PARAM_IN;


	methods[14].param_types=new org.omg.CORBA.TypeCode[2];
	methods[14].param_types[0]=orb.get_primitive_tc(org.omg.CORBA.TCKind.tk_string);
	methods[14].param_types[1]=orb.get_primitive_tc(org.omg.CORBA.TCKind.tk_string);

	//get job
	methods[15]=new universal.MethSignStr();
	methods[15].name="get_job";
	methods[15].readMethod=false;

	methods[15].param_modes=new int[2];
	methods[15].param_modes[0]=org.omg.CORBA.ParameterMode._PARAM_IN;
	methods[15].param_modes[1]=org.omg.CORBA.ParameterMode._PARAM_IN;


	methods[15].param_types=new org.omg.CORBA.TypeCode[2];
	methods[15].param_types[0]=orb.get_primitive_tc(org.omg.CORBA.TCKind.tk_longlong);
	methods[15].param_types[1]=orb.get_primitive_tc(org.omg.CORBA.TCKind.tk_string);

	//get activities in job
	methods[16]=new universal.MethSignStr();
	methods[16].name="get_activities_in_job";
	methods[16].readMethod=false;

	methods[16].param_modes=new int[2];
	methods[16].param_modes[0]=org.omg.CORBA.ParameterMode._PARAM_IN;
	methods[16].param_modes[1]=org.omg.CORBA.ParameterMode._PARAM_IN;


	methods[16].param_types=new org.omg.CORBA.TypeCode[2];
	methods[16].param_types[0]=orb.get_primitive_tc(org.omg.CORBA.TCKind.tk_longlong);
	methods[16].param_types[1]=orb.get_primitive_tc(org.omg.CORBA.TCKind.tk_string);

	//report status and result
	methods[17]=new universal.MethSignStr();
	methods[17].name="report_status_and_result";
	methods[17].readMethod=false;

	methods[17].param_modes=new int[3];
	methods[17].param_modes[0]=org.omg.CORBA.ParameterMode._PARAM_IN;
	methods[17].param_modes[1]=org.omg.CORBA.ParameterMode._PARAM_IN;
	methods[17].param_modes[2]=org.omg.CORBA.ParameterMode._PARAM_IN;


	methods[17].param_types=new org.omg.CORBA.TypeCode[3];
	methods[17].param_types[0]=orb.get_primitive_tc(org.omg.CORBA.TCKind.tk_longlong);
	methods[17].param_types[1]=com.ericsson.nms.cif.am.ActivityManager.ActivityReportStatusHelper.type();
	methods[17].param_types[2]=com.ericsson.nms.cif.am.ActivityManager.AttributeSeqHelper.type();

	//report progress
	methods[18]=new universal.MethSignStr();
	methods[18].name="report_progress";
	methods[18].readMethod=false;

	methods[18].param_modes=new int[2];
	methods[18].param_modes[0]=org.omg.CORBA.ParameterMode._PARAM_IN;
	methods[18].param_modes[1]=org.omg.CORBA.ParameterMode._PARAM_IN;


	methods[18].param_types=new org.omg.CORBA.TypeCode[2];
	methods[18].param_types[0]=orb.get_primitive_tc(org.omg.CORBA.TCKind.tk_longlong);
	methods[18]. param_types[1]=orb.get_primitive_tc(org.omg.CORBA.TCKind.tk_long);

	//terminate job
	methods[19]=new universal.MethSignStr();
	methods[19].name="terminate_job";
	methods[19].readMethod=false;

	methods[19].param_modes=new int[2];
	methods[19].param_modes[0]=org.omg.CORBA.ParameterMode._PARAM_IN;
	methods[19].param_modes[1]=org.omg.CORBA.ParameterMode._PARAM_IN;


	methods[19].param_types=new org.omg.CORBA.TypeCode[2];
	methods[19].param_types[0]=orb.get_primitive_tc(org.omg.CORBA.TCKind.tk_longlong);
	methods[19].param_types[1]=orb.get_primitive_tc(org.omg.CORBA.TCKind.tk_string);

	//remove job
	methods[20]=new universal.MethSignStr();
	methods[20].name="remove_job";
	methods[20].readMethod=false;

	methods[20].param_modes=new int[2];
	methods[20].param_modes[0]=org.omg.CORBA.ParameterMode._PARAM_IN;
	methods[20].param_modes[1]=org.omg.CORBA.ParameterMode._PARAM_IN;


	methods[20].param_types=new org.omg.CORBA.TypeCode[2];
	methods[20].param_types[0]=orb.get_primitive_tc(org.omg.CORBA.TCKind.tk_longlong);
	methods[20].param_types[1]=orb.get_primitive_tc(org.omg.CORBA.TCKind.tk_string);


    }


}
