package universal;
/**
 *Struct definition : RequestServiceContext
 * the structure was defined in the FTC.idl file (as FTRequestServiceContext) that can be found in the FT-CORBA infrastructure distribution
 *<dl>Add a service context to the request when it goes through the clientInterceptor in the method send_request.</dl>
 *@author OpenORB Compiler
 */
public final class RequestServiceContext implements org.omg.CORBA.portable.IDLEntity
{
    /**
     * Struct member request_start_time.
     *Associates to the request the current time when it is in the client Interceptor in the method send_request.
     *It will be needed to calculate the expiration time (request_start_time + certain_duration).
     */
	public long request_start_time;

    /**
     * Struct member retention_id.
     *A different retention_id is associated to each request.
     */
	public int retention_id;

    /**
     * Struct member client_id.
     *Each client has its own client id.
     */
	public String client_id;

	//
	// Default constructor
	//
	public RequestServiceContext()
	{ }

	//
	// Constructor with fields initialization
	// @param	request_start_time	request_start_time struct member
	// @param	retention_id	retention_id struct member
	// @param	client_id	client_id struct member
	//
	public RequestServiceContext( long request_start_time, int retention_id, String client_id )
	{
		this.request_start_time = request_start_time;
		this.retention_id = retention_id;
		this.client_id = client_id;
	}

}
