package universal;
/**
 *Helper class for : RequestServiceContext
 *
 * @author OpenORB Compiler
 */
public class RequestServiceContextHelper
{
	private static final boolean HAS_OPENORB;
	static {
		boolean hasOpenORB = false;
		try {
			Class.forName("org.openorb.CORBA.Any");
			hasOpenORB = true;
		}
		catch(ClassNotFoundException ex) {
		}
		HAS_OPENORB = hasOpenORB;
	}
    /**
     * Insert RequestServiceContext into an any
     * @param	a an any
     * @param	t RequestServiceContext value
     */
	public static void insert( org.omg.CORBA.Any a, RequestServiceContext t )
	{
		a.insert_Streamable( new RequestServiceContextHolder( t ));
	}

    /**
     * Extract RequestServiceContext from an any
     * @param	a an any
     * @return the extracted RequestServiceContext value
     */
	public static RequestServiceContext extract( org.omg.CORBA.Any a )
	{
		if ( !a.type().equal( type() ) )
			throw new org.omg.CORBA.MARSHAL();
		if(HAS_OPENORB && a instanceof org.openorb.CORBA.Any) {
			// streamable extraction. The jdk stubs incorrectly define the Any stub
			org.openorb.CORBA.Any any = (org.openorb.CORBA.Any)a;
			try {
				org.omg.CORBA.portable.Streamable s = any.extract_Streamable();
				if(s instanceof RequestServiceContextHolder)
					return ((RequestServiceContextHolder)s).value;
			}
			catch ( org.omg.CORBA.BAD_INV_ORDER ex ) {}
			RequestServiceContextHolder h = new RequestServiceContextHolder(read(a.create_input_stream()));
			a.insert_Streamable(h);
			return h.value;
		}
		return read(a.create_input_stream());
	}

    /**
     *Internal TypeCode value
     */
	private static org.omg.CORBA.TypeCode _tc = null;
	private static boolean _working = false;

    /**
     * Return the RequestServiceContext TypeCode
     * @return a TypeCode
     */
	public static org.omg.CORBA.TypeCode type()
	{
		if ( _tc == null ) {
			synchronized(org.omg.CORBA.TypeCode.class) {
				if ( _tc != null )
					return _tc;
				if ( _working )
					return org.omg.CORBA.ORB.init().create_recursive_tc( id() );
				_working = true;
				org.omg.CORBA.ORB orb = org.omg.CORBA.ORB.init();
				org.omg.CORBA.StructMember []_members = new org.omg.CORBA.StructMember[3];

				_members[0] = new org.omg.CORBA.StructMember();
				_members[0].name = "request_start_time";
				_members[0].type = orb.get_primitive_tc(org.omg.CORBA.TCKind.tk_longlong);
				_members[1] = new org.omg.CORBA.StructMember();
				_members[1].name = "retention_id";
				_members[1].type = orb.get_primitive_tc(org.omg.CORBA.TCKind.tk_long);
				_members[2] = new org.omg.CORBA.StructMember();
				_members[2].name = "client_id";
				_members[2].type = orb.get_primitive_tc( org.omg.CORBA.TCKind.tk_string );
				_tc = orb.create_struct_tc(id(),"RequestServiceContext",_members);
				_working = false;
			}
		}
		return _tc;
	}

    /**
     * Return the RequestServiceContext IDL ID
     * @return an ID
     */
	public static String id()
	{
		return _id;
	}

	private final static String _id = "IDL:RequestServiceContext:1.0";

    /**
     * Read RequestServiceContext from a marshalled stream
     * @param	istream the input stream
     * @return the readed RequestServiceContext value
     */
	public static RequestServiceContext read( org.omg.CORBA.portable.InputStream istream )
	{
		RequestServiceContext new_one = new RequestServiceContext();

		new_one.request_start_time = istream.read_longlong();
		new_one.retention_id = istream.read_long();
		new_one.client_id = istream.read_string();

		return new_one;
	}

    /**
     * Write RequestServiceContext into a marshalled stream
     * @param	ostream the output stream
     * @param	value RequestServiceContext value
     */
	public static void write( org.omg.CORBA.portable.OutputStream ostream, RequestServiceContext value )
	{
		ostream.write_longlong(value.request_start_time);
		ostream.write_long(value.retention_id);
		ostream.write_string(value.client_id);
	}

}
