/**
  * Redistribution and use of this software and associated
  * documentation ("Software"), with or without modification, are
  * permitted provided that the following conditions are met:
  *
  * 1. Redistributions of source code must retain copyright statements
  *    and notices.  Redistributions must also contain a copy of this
  *    document.
  *
  * 2. Redistributions in binary form must reproduce the above
  *    copyright notice, this list of conditions and the following
  *    disclaimer in the documentation and/or other materials provided
  *    with the distribution.
  *
  * 3. The names "TRANSORG" or "EUTIST-AMI" must not be used to endorse or promote
  *    products derived from this Software without prior written
  *    permission of one of the parties involved in the TRANSORG project. For
  * 	  written permission, please contact diasz@ida.liu.se.
  *
  * 4. Products derived from this Software may not be called "TRANSORG"
  *    nor may "TRANSORG" appear in their names without prior written
  *    permission.
  *
  * 5. Due credit should be given to the TRANSORG Project
  *    (http://www.ida.liu.se/~rtslab/TRANSORG/).
  *
  * THIS SOFTWARE IS PROVIDED BY THE TRANSORG PROJECT CONTRIBUTORS ``AS IS'' AND
  * ANY EXPRESSED OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
  * THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A
  * PARTICULAR PURPOSE ARE DISCLAIMED.
  *
  * IN NO EVENT SHALL THE TRANSORG PROJECT CONTRIBUTORS
  * BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
  * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE
  * GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
  * CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
  * OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT
  * OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
  * SUCH DAMAGE.
  *
  * Copyright 2003 (C) TRANSORG Project Contributors All Rights Reserved.
  *
  * $Id: UpdateOrState.java,v 1.0  diasz Exp $
  *
  * Date         Author  Changes
  */

package universal;
/*
 * Author       : Isabelle Ravot
 * Date         : 01/08/02
 * Last changes : 01/08/02
 * Contact		: diasz@ida.liu.se
 */

import java.io.*;
import java.util.*;

// Object  Update

public class UpdateOrState implements Serializable
{

    public byte[] upd_or_state;
    public UpdateOrState(byte[] upd_or_state)
    {
	this.upd_or_state=new byte[upd_or_state.length];
	java.lang.System.arraycopy(upd_or_state,0,this.upd_or_state,0,upd_or_state.length);
    }
    public UpdateOrState()
    {
    }
    public void writeObject(DataOutputStream dos)
    {
	try
	    {
		if(upd_or_state!=null)
		    {
			dos.writeInt(upd_or_state.length);
			for(int i=0;i<upd_or_state.length;i++)
			    {
				dos.writeByte(upd_or_state[i]);
			    }

		    }
		else
		    {
			dos.writeInt(0);
		    }
	    }
	catch (IOException e)
	    {
		e.printStackTrace();
	    }
    }
    public void readObject(DataInputStream dis)
    {

	try
	    {
		int lngth = dis.readInt();

		upd_or_state=new byte[lngth];

		for(int i=0;i<lngth;i++)
		    {
			upd_or_state[i]=dis.readByte();
		    }
	    }
	catch (IOException e)
	    {
		e.printStackTrace();
	    }

    }

}
