/**
 * Redistribution and use of this software and associated
 * documentation ("Software"), with or without modification, are
 * permitted provided that the following conditions are met:
 *
 * 1. Redistributions of source code must retain copyright statements
 *    and notices.  Redistributions must also contain a copy of this
 *    document.
 *
 * 2. Redistributions in binary form must reproduce the above
 *    copyright notice, this list of conditions and the following
 *    disclaimer in the documentation and/or other materials provided
 *    with the distribution.
 *
 * 3. The names "TRANSORG" or "EUTIST-AMI" must not be used to endorse or promote
 *    products derived from this Software without prior written
 *    permission of one of the parties involved in the TRANSORG project. For
 * 	  written permission, please contact diasz@ida.liu.se.
 *
 * 4. Products derived from this Software may not be called "TRANSORG"
 *    nor may "TRANSORG" appear in their names without prior written
 *    permission.
 *
 * 5. Due credit should be given to the TRANSORG Project
 *    (http://www.ida.liu.se/~rtslab/TRANSORG/).
 *
 * THIS SOFTWARE IS PROVIDED BY THE TRANSORG PROJECT CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESSED OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
 * THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A
 * PARTICULAR PURPOSE ARE DISCLAIMED.
 *
 * IN NO EVENT SHALL THE TRANSORG PROJECT CONTRIBUTORS
 * BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
 * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE
 * GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
 * CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
 * OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT
 * OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 * Copyright 2003 (C) TRANSORG Project Contributors All Rights Reserved.
 *
 * $Id: WriteMessage.java,v 1.0  diasz Exp $
 *
 * Date         Author  Changes
 */

package universal;

/*
 * Author       : Rahul Agarwal
 * Modify       : Isabelle Ravot
 * Date         : 25/05/00
 * Last changes : 01/08/02
 * Contact		: diasz@ida.liu.se
 */
import java.io.*;
import java.util.*;
import java.net.*;

/*
 * Used when writing in register
 */
public class WriteMessage extends Message{

  public int roundno;
  public int batchno;
  public Outcome value;

   public int Kpj;
    //public Vector piggyback;


protected WriteMessage()
{
	msgType = WRITE_MSG;
}


public WriteMessage(int batchno, int roundno, Outcome value)
{
	msgType = WRITE_MSG;

	this.batchno = batchno;
	this.roundno = roundno;
	this.value = value;
	Debug.println("I am constructing the write Message");
	Kpj = -1;
	//piggyback = null;
}


public WriteMessage(int batchno, int roundno, Outcome value, int Kpj)
{
    msgType = WRITE_MSG;

    this.batchno = batchno;
    this.roundno = roundno;
    this.value = value;

    this.Kpj = Kpj;
    //this.piggyback = piggyback;
}


public static WriteMessage decode(DataInputStream dis)
{
	int newBatchno;
	int newRoundno;
	Outcome newValue;

	int newKpj;
	//Vector newPiggyback;

	try
	{
		/* encoding:

		dos.writeInt(msgType);
		dos.writeInt(senderid);
		dos.writeInt(mid);
		dos.writeInt(batchno);
		dos.writeInt(roundno);
		if (value != null)
		{
			dos.writeInt(value.size());
			for (int i=0; i<value.size(); i++)
			{
				TOBroadcastMessage m = (TOBroadcastMessage)value.elementAt(i);
				dos.write(m.encode());
			}
		}
		else
		{
			dos.writeInt(-1);
		}

		dos.writeInt(Kpj);

		if (piggyback != null)
		{
			dos.writeInt(piggyback.size());
			for (int i=0; i<piggyback.size(); i++)
			{
				TOBroadcastMessage m = (TOBroadcastMessage)value.elementAt(i);
				dos.write(m.encode());
			}
		}
		else
		{
			dos.writeInt(-1);
		}

		*/

		newBatchno = dis.readInt();
		newRoundno = dis.readInt();

		//	int j = dis.readInt();
		newValue=new Outcome();
		newValue.readObject(dis);
		/*
		  try
		  {
		  ObjectInputStream obj = new ObjectInputStream(dis);
		  Debug.println("I am decoding the retention_id "+obj);
		  newValue=(Outcome)obj.readObject();
		  Debug.println("I am going to decode the message for the retention_id "+newValue.req.retention_id);
		  Debug.println("The size of the update state"+newValue.upd.upd.length);

		  obj.close();
		  }
		  catch (java.lang.ClassNotFoundException e)
		  {
		  e.printStackTrace();
		  }
		*/

		/*
		  if (len != -1)
		  {
		  for (int i=0; i<len; i++)
		  {
		  newValue.addElement(TOBroadcastMessage.fullDecode(dis));
		  }
		  }
		  else
		  newValue = null;
		*/

		newKpj = dis.readInt();
		/*
			len = dis.readInt();
			newPiggyback = new Vector();
			if (len != -1)
			{
			for (int i=0; i<len; i++)
			{
			 	newPiggyback.addElement(TOBroadcastMessage.fullDecode(dis));
			}
			}
			else
			newPiggyback = null;
		*/

		return new WriteMessage(newBatchno, newRoundno, newValue, newKpj);
	}
	catch (IOException e)
	{
		e.printStackTrace();
	}

	return null;
}



public byte[] encode()
{
	ByteArrayOutputStream baos = new ByteArrayOutputStream();
	DataOutputStream dos = new DataOutputStream(baos);
	byte[] byteValue=null;
	try
	{
	    //Debug.println("message encodage");
		dos.writeInt(msgType);
		dos.writeInt(senderid);
		dos.writeInt(mid);
		dos.writeInt(batchno);
		dos.writeInt(roundno);
		value.writeObject(dos);
		//	if (value != null)
		//{
		/*
		  try
		  {
		  ObjectOutputStream obj = new ObjectOutputStream(dos);
		  Debug.println("I am going to write the message for the retention_id "+value.req.retention_id);
		  Debug.println("The size of the update state"+value.upd.upd.length);
		  obj.writeObject(value);
		  obj.close();
		  }
		  catch (IOException e)
		  {
		  e.printStackTrace();
		  }
		*/
		    //}
		    //else
		    //{
		    //dos.writeInt(-1);
		    //}

		dos.writeInt(Kpj);
		/*
		  if (piggyback != null)
		  {
		  dos.writeInt(piggyback.size());
		  for (int i=0; i<piggyback.size(); i++)
		  {
		  TOBroadcastMessage m = (TOBroadcastMessage)piggyback.elementAt(i);
		  dos.write(m.encode());
		  }
		  }
		  else
		  {
		  dos.writeInt(-1);
		  }
		*/
		dos.flush();
		byteValue=baos.toByteArray();
		baos.flush();
		dos.close();
		baos.close();
	}
	catch (IOException e)
	{
		e.printStackTrace();
	}

	return byteValue;
}



/**
 * Compares two objects for equality. Returns a boolean that indicates
 * whether this object is equivalent to the specified object. This method
 * is used when an object is stored in a hashtable.
 * @param obj the Object to compare with
 * @return true if these Objects are equal; false otherwise.
 * @see java.util.Hashtable
 */
public boolean equals(Object obj) {

	if (!(obj instanceof WriteMessage))
		return false;

	WriteMessage m = (WriteMessage)obj;

	if (m.senderid == senderid && m.batchno == batchno && m.roundno == roundno)
		return true;
	else
		return false;
}



public String toString() {
	return "WRITE ("+batchno+", "+roundno+")";
}
}
