/**
  * Redistribution and use of this software and associated
  * documentation ("Software"), with or without modification, are
  * permitted provided that the following conditions are met:
  *
  * 1. Redistributions of source code must retain copyright statements
  *    and notices.  Redistributions must also contain a copy of this
  *    document.
  *
  * 2. Redistributions in binary form must reproduce the above
  *    copyright notice, this list of conditions and the following
  *    disclaimer in the documentation and/or other materials provided
  *    with the distribution.
  *
  * 3. The names "TRANSORG" or "EUTIST-AMI" must not be used to endorse or promote
  *    products derived from this Software without prior written
  *    permission of one of the parties involved in the TRANSORG project. For
  * 	  written permission, please contact diasz@ida.liu.se.
  *
  * 4. Products derived from this Software may not be called "TRANSORG"
  *    nor may "TRANSORG" appear in their names without prior written
  *    permission.
  *
  * 5. Due credit should be given to the TRANSORG Project
  *    (http://www.ida.liu.se/~rtslab/TRANSORG/).
  *
  * THIS SOFTWARE IS PROVIDED BY THE TRANSORG PROJECT CONTRIBUTORS ``AS IS'' AND
  * ANY EXPRESSED OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
  * THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A
  * PARTICULAR PURPOSE ARE DISCLAIMED.
  *
  * IN NO EVENT SHALL THE TRANSORG PROJECT CONTRIBUTORS
  * BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
  * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE
  * GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
  * CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
  * OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT
  * OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
  * SUCH DAMAGE.
  *
  * Copyright 2003 (C) TRANSORG Project Contributors All Rights Reserved.
  *
  * $Id: ReceiverClient.java,v 1.0   Exp $
  *
  */

package universal.communication;
/*
 * Author       : Rahul Agarwal
 * Modify       : Isabelle Ravot
 * Date         : 25/05/00
 * Last changes : 01/08/02
 * Contact		: diasz@ida.liu.se
 */




import java.util.*;
import java.net.*;
import java.io.*;
import universal.*;
// import universal.consensus.*;
import universal.leader.*;

/**
 * This subclass implements the crash stop model receiver in the side of the client.
 * It is waiting for AmAlive messages from the replicated servers.
 */
public class ReceiverClient implements Runnable
{
    // Buffers for the different types of messages received
    // public Vector UniversalBuffer;
    // public Vector DecisionBuffer;
    // public Vector PaxosUpdateBuffer;
    // public Vector ReadBuffer;

    /** List of the replicated servers*/
    public Vector processes;

    // thread which deals with decision messages
    //public ReceiveDecision receiveDecision;

    /**The Universal object this receiver is linked to*/
    UniversalClient uniClient ;
    Socket clientSocket;

    /**Start the thread to listen for new messages to arrive*/
public ReceiverClient(UniversalClient univClient)
{
    // UniversalBuffer = new Vector();
    // DecisionBuffer = new Vector();
    // PaxosUpdateBuffer = new Vector();
    // ReadBuffer = new Vector();
    processes = new Vector();

	uniClient = univClient;
    // receiveDecision = new ReceiveDecision(to);

	Thread t = new Thread(this, "Receiver");
	t.start();

}

public LeaderCrashStopClient leader()
    {
	return uniClient.lead;
    }

    /**
     * Waits for new packet to arrive and then return as an Object the message that has been decoded.
     */
public Object receive() throws IOException, ClassNotFoundException
{
    //TCP socket
    try {
	clientSocket = uniClient.serverSocket.accept();
    } catch (IOException e) {
	e.printStackTrace();
    }
    byte[] byteArray = new byte[Constants.MAX_OBJECT_LENGTH];
    //byte[] byteArray=null;
    InputStream in = clientSocket.getInputStream();
    //DataInputStream din =new DataInputStream(in);
    BufferedInputStream bin=new BufferedInputStream(in);
    //int length=0;
    int lengthread=0;
    int byteRead=0;
    int m=0;
    while(byteRead!=-1)
	{
	    byteRead=bin.read();
	    byteArray[m]=(byte)byteRead;
	    m=m+1;
	}
    lengthread=m-1;
    /*
	  try
	  {
	  length=din.readInt();
	  byteArray = new byte[length];
	  while(lengthread!=length)
	  {
	  if((length-lengthread)<=1000)
	  {
	  lengthread = lengthread+din.read(byteArray,lengthread,(length-lengthread));
	  }
	  else
	  {
	  lengthread = lengthread+din.read(byteArray,lengthread,1000);
			}
			System.out.println("I have read "+lengthread);
			}
			//while(lengthread!=length)
			//{
	    //    lengthread=lengthread+din.read(byteArray,lengthread,length);
	    //}
	    //din.readFully(byteArray);
	    }
	    catch(java.lang.Exception e)
	    {
	    System.out.println("problem with reading");
	    e.printStackTrace();
	    }
    */
    System.out.println("The size  we read "+lengthread);
    try
	{
	    //din.close();
	    bin.close();
	    in.close();
	    clientSocket.close();
	}
    catch(java.io.IOException ex)
	{
	    ex.printStackTrace();
	}
    //in.read(byteArray);
    //in.close();
    //clientSocket.close();
    //DatagramPacket packet = new DatagramPacket(byteArray, byteArray.length);

    //uni.socket.receive(packet);

    return Message.decode(byteArray);

}

/*
public Register reg() {
	return uni.reg;
}
*/

/**
 * Waits for AmAlive messages and then informs the leader part of our algorithm that
 *an AmAlive message has arrived.
 */
public void run()
{
	Message m = null;

	for (;;)
	{
		try
		{
			m = (Message) receive();

		}
		catch (ClassNotFoundException e)
		{
			System.err.println("Class not found Exception in receiver ");
		}
		catch (IOException e)
		{
			//System.err.println("IO Exception in receiver ");
			//e.printStackTrace();
			continue;
		}


			if (leader() != null)
				leader().receivedAmAlive((AmAliveMessage)m);


	}
}
public int totalno()
{
    return processes.size();
}
}
