/**
  * Redistribution and use of this software and associated
  * documentation ("Software"), with or without modification, are
  * permitted provided that the following conditions are met:
  *
  * 1. Redistributions of source code must retain copyright statements
  *    and notices.  Redistributions must also contain a copy of this
  *    document.
  *
  * 2. Redistributions in binary form must reproduce the above
  *    copyright notice, this list of conditions and the following
  *    disclaimer in the documentation and/or other materials provided
  *    with the distribution.
  *
  * 3. The names "TRANSORG" or "EUTIST-AMI" must not be used to endorse or promote
  *    products derived from this Software without prior written
  *    permission of one of the parties involved in the TRANSORG project. For
  * 	  written permission, please contact diasz@ida.liu.se.
  *
  * 4. Products derived from this Software may not be called "TRANSORG"
  *    nor may "TRANSORG" appear in their names without prior written
  *    permission.
  *
  * 5. Due credit should be given to the TRANSORG Project
  *    (http://www.ida.liu.se/~rtslab/TRANSORG/).
  *
  * THIS SOFTWARE IS PROVIDED BY THE TRANSORG PROJECT CONTRIBUTORS ``AS IS'' AND
  * ANY EXPRESSED OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
  * THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A
  * PARTICULAR PURPOSE ARE DISCLAIMED.
  *
  * IN NO EVENT SHALL THE TRANSORG PROJECT CONTRIBUTORS
  * BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
  * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE
  * GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
  * CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
  * OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT
  * OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
  * SUCH DAMAGE.
  *
  * Copyright 2003 (C) TRANSORG Project Contributors All Rights Reserved.
  *
  * $Id: Register.java,v 1.0   Exp $
  *
  */

package universal.consensus.register;
/*
 * Author		: Rahul Agarwal
 * Modify       : Isabelle Ravot and Diana Szentivanyi
 * Date         : 01/08/02
 * Last changes : 18/02/03
 * Contact		: diasz@ida.liu.se
 */

import java.util.*;
import java.io.*;
import universal.*;



public class Register
{
    /**The thread who is going to wait for ReadMessage from the leader*/
    public ReadListener readlistener;
    /**The thread who is going to wait for WriteMessage from the leader*/
    public WriteListener writelistener;
    /**The thread who is going to wait for Acknowledgement Message from the replicated servers*/
    public AckListener acklistener;
    /**The HahsTable of registry which contains the request decided for each position in the total order*/
    public Vector registry = new Vector();
    /**The object universal the register is linked to*/
    public Universal uni;

    /** added by Diana on Feb. 17 2003*/

    public Hashtable result_registry=new Hashtable();

    /**Instantiate the object ReadListener, WriteListenner and AckListener*/
    public Register(Universal uni)
    {
	this.uni = uni;
	readlistener = new ReadListener(this);
	writelistener = new WriteListener(this);
	acklistener = new AckListener(this);
	/*not useful for the moment
	  if (uni instanceof TOBroadcastCrashRecovery)
	  {
	  if (((TOBroadcastCrashRecovery) uni).recovering)
	  {
	  try
	  {
	  retreive();
	  Debug.println("Registry recovered");
	  }
	  catch (IOException e)
	  {
	  System.err.println("IO Exception when retreiving registry");
	  }
	  }
	  }
	*/
    }
    public ReadListener getReadlistener()
    {
	return readlistener;
    }
    public WriteListener getWritelistener()
    {
	return writelistener;
    }
    public AckListener getAcklistener()
    {
	return acklistener;
    }

    /*  public void printRegister()
    {
	Debug.println("State of registry: ");
	for (int i = 0; i < registry.size(); i++)
	{
	    Integer ii =new Integer(i);
	    if (registry.containsKey(ii))
		{
		    Debug.println(i+": "+((Registry)(registry.get(ii))).lastread+", "+((Registry)(registry.get(ii))).lastwrite);

		}
	}
	}*/
    /*
      public void retreive() throws java.io.IOException
      {
      Debug.println("Retreiving registry");
      String filename = "Registry_port" + new Integer(uni.port).toString() + ".uni";
      for (int i = 0; i < registry.size(); i++)
      {
      try
      {
      ObjectInputStream is = new ObjectInputStream(new FileInputStream(i + filename));

      registry[i] = new Registry(uni);
      registry[i].lastread = is.readInt();
      registry[i].lastwrite = is.readInt();
      try
      {
      registry[i].out = (Outcome) is.readObject();
      }
      catch (ClassNotFoundException e)
      {
      e.printStackTrace();
      }
      is.close();
      }
      catch (FileNotFoundException e)
      {
      // If file not found, registry did not exist yet
      }
      }

      }
    */
}
