package universal.exception;

//
// Exception definition : NotUserException
//
// @author OpenORB Compiler
//
import universal.exception.*;
/**
 *This exception is thrown when the replicated server that receives a request finally doesn't trust itself
 *as the leader.
 *<dt>The client is waiting for a response, so this exception is thrown .Like this instead of waiting the client will
 *resend the request.
 *<dt>If in the method Invoke of the org.omg.CORBA.Delegate we catch an UserException, we test if this exception
 *is of type NotUserException. If it is the case, we send org.omg.CORBA.portable.StopMarshallException.
 *When this StopMarshallException is catched in the Stub of the application, we restart the process to
 *send a request from the beginning.
 */
public final class NotUserException extends org.omg.CORBA.UserException
{
	//
	// Exception member errorcode
	//
	public int errorcode;

	//
	// Exception member reason
	//
	public String reason;

	//
	// Default constructor
	//
	public NotUserException()
	{
		super( universal.exception.NotUserExceptionHelper.id() );
		reason="";
	}

	//
	// Constructor with fields initialization
	// @param	errorcode	errorcode exception member
	// @param	reason	reason exception member
	//
	public NotUserException( int errorcode, String reason )
	{
		super( universal.exception.NotUserExceptionHelper.id() );
		this.errorcode = errorcode;
		this.reason = reason;
	}

	//
	// Full constructor with fields initialization
	// @param	errorcode	errorcode exception member
	// @param	reason	reason exception member
	//
	public NotUserException( String orb_reason, int errorcode, String reason )
	{
		super( NotUserExceptionHelper.id() +" " +  orb_reason );
		this.errorcode = errorcode;
		this.reason = reason;
	}

}
