/**
 * Redistribution and use of this software and associated
 * documentation ("Software"), with or without modification, are
 * permitted provided that the following conditions are met:
 *
 * 1. Redistributions of source code must retain copyright statements
 *    and notices.  Redistributions must also contain a copy of this
 *    document.
 *
 * 2. Redistributions in binary form must reproduce the above
 *    copyright notice, this list of conditions and the following
 *    disclaimer in the documentation and/or other materials provided
 *    with the distribution.
 *
 * 3. The names "TRANSORG" or "EUTIST-AMI" must not be used to endorse or promote
 *    products derived from this Software without prior written
 *    permission of one of the parties involved in the TRANSORG project. For
 * 	  written permission, please contact diasz@ida.liu.se.
 *
 * 4. Products derived from this Software may not be called "TRANSORG"
 *    nor may "TRANSORG" appear in their names without prior written
 *    permission.
 *
 * 5. Due credit should be given to the TRANSORG Project
 *    (http://www.ida.liu.se/~rtslab/TRANSORG/).
 *
 * THIS SOFTWARE IS PROVIDED BY THE TRANSORG PROJECT CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESSED OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
 * THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A
 * PARTICULAR PURPOSE ARE DISCLAIMED.
 *
 * IN NO EVENT SHALL THE TRANSORG PROJECT CONTRIBUTORS
 * BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
 * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE
 * GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
 * CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
 * OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT
 * OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 * Copyright 2003 (C) TRANSORG Project Contributors All Rights Reserved.
 *
 * $Id: Utils.java,v 1.0   Exp $
 *
 */

 /** Author		: Diana Szentivanyi
  * Last changed: 23/05/03
  * Contact		: diasz@ida.liu.se
 */

package universal.utils;
import org.omg.CORBA.*;
import org.omg.CORBA.portable.*;
import org.omg.IOP.*;
import java.util.*;

public class Utils{

    private static java.lang.Object semaphor;
    private static String ft_dom_name_fn="/home/diasz/Research/Experiments/trials/FT_DOMAINS";

    public final static char UPDATE_VOID='v';
    public final static char UPDATE_NON_VOID='u';
    public final static char UPDATE_ONEWAY='o';
    public final static char READ='r';


    public static final int START_CALL_BY_CLIENT=0;
    public static final int EXIT_SEND_REQUEST=1;
    public static final int ENTER_RECEIVE_REQUEST=2;
    public static final int YES_REQUEST_RIGHT_PLACE=3;
    public static final int SEND_FORWARD_EXC=4;
    public static final int SEND_WR_PRIM_EXC=5;
    public static final int SEND_REQ_EXP_EXC=6;
    public static final int START_WAIT_GET_STATE=7;
    public static final int STOP_WAIT_GET_STATE=8;
    public static final int EXIT_RECEIVE_REQUEST=9;
    public static final int ENTER_SEND_REPLY=10;
    public static final int EXIT_SEND_REPLY=11;
    public static final int ENTER_RECEIVE_REPLY=12;
    public static final int EXIT_RECEIVE_REPLY=13;
    public static final int END_CALL_BY_CLIENT=14;

    public static final int ENTER_RECEIVE_REQUEST_G=15;
    public static final int BEG_SYNCH_FAILOVER=16;
    public static final int END_SYNCH_FAILOVER=17;
    public static final int EXIT_SEND_REPLY_GW=18;
    public static final int END_SYNCH_SEND_CALLS=19;
    public static final int GW_SEND_TRANSIENT=20;
    public static final int GW_SEND_REQUESTS=21;
    public static final int RECEIVE_FIRST_REPLY=22;

    public static final int ENTER_SEND_REQUEST=23;
    public static final int CALL_INVOKE=24;
    public static final int INV_EXITS_SEND_REQUEST=25;
    public static final int START_WAIT_ANSWER_GW=26;
    public static final int GET_ANSWER_GW=27;
    public static final int THROW_REPLY_HERE=28;

    public static final int REPL_MAN_BEGIN_REC=29;
    public static final int REPL_MAN_END_REC=30;
    public static final int REPL_MAN_REC_F_NOT=31;
    public static final int REPL_MAN_BEGIN_CR_OBJ=32;
    public static final int REPL_MAN_END_CR_OBJ=33;


    public static final int EXIT_REPLY_ALREADY_THERE=34;
    public static final int RECEIVE_EXCEPTION=35;
    public static final int RECEIVE_OTHER=36;
    public static final int SEND_REQ_EXP_EXC_GW=37;

    public static final int SEND_EXCEPTION=38;
    public static final int SEND_OTHER=39;
    public static final int SEND_EXCEPTION_RM=40;
    public static final int SEND_OTHER_RM=41;

    public static final int START_GET_STATE=42;
    public static final int STOP_GET_STATE=43;
    public static final int START_GET_UPDATE=44;
    public static final int STOP_GET_UPDATE=45;

    public static final int START_REC_BR_METHOD_CALL=46;
    public static final int STOP_REC_BR_METHOD_CALL=47;
    public static final int START_REC_BR_REPLY=48;
    public static final int STOP_REC_BR_REPLY=49;

    public static final int START_REC_METHOD_CALL=50;
    public static final int STOP_REC_METHOD_CALL=51;
    public static final int START_REC_REPLY=52;
    public static final int STOP_REC_REPLY=53;

    public static final int REPL_MAN_BEG_GET_STATE=54;
    public static final int REPL_MAN_END_GET_STATE=55;
    public static final int REPL_MAN_BEG_SET_STATE=56;
    public static final int REPL_MAN_END_SET_STATE=57;

    public static final int START_WAIT_UPD_OPER=58;
    public static final int STOP_WAIT_UPD_OPER=59;
    public static final int START_GET_S_WAIT=60;
    public static final int STOP_GET_S_WAIT=61;
    public static final int START_GET_U_WAIT=62;
    public static final int STOP_GET_U_WAIT=63;
    public static final int START_GET_STATE_CALL=64;
    public static final int STOP_GET_STATE_CALL=65;
    public static final int START_STATE_REC=66;
    public static final int STOP_STATE_REC=67;
    public static final int SEND_GET_STATE_REQ=68;
    public static final int REC_GET_STATE_REQ=69;
    public static final int SEND_GET_STATE_REPLY=70;
    public static final int REC_GET_STATE_REPLY=71;
     public static final int START_GET_UPDATE_CALL=72;
    public static final int STOP_GET_UPDATE_CALL=73;
    public static final int START_UPDATE_REC=74;
    public static final int STOP_UPDATE_REC=75;
    public static final int SEND_GET_UPDATE_REQ=76;
    public static final int REC_GET_UPDATE_REQ=77;
    public static final int SEND_GET_UPDATE_REPLY=78;
    public static final int REC_GET_UPDATE_REPLY=79;
    public static final int START_SET_STATE=80;
    public static final int STOP_SET_STATE=81;

/** The constants below are mainly used to trace timing information*/

    /** Constant designating the moment when in the server interceptor the request starts
    * its passage through the operations of the algortihm (equivalent to the moment of entering the request
    * interceptor at the server replica*/
    public static final int START_PROC=82;
    /** Constant designating the moment when the lookup in the outcome store starts
    */
    public static final int START_LOOKUP=83;
    /** Constant designating the moment when the lookup in the outcome store stops
    */
    public static final int STOP_LOOKUP=84;
    /** Constant designating the moment when the request processing stops because the reply is in the outcome store
    */
    public static final int STOP_PROC_REPLY_THERE=85;

    /** Constant designating the moment when the (simulated) tentative execuiton of the request starts
    */
    public static final int START_TENT_EXEC=86;

    /** Constant designating the moment when the state of the object starts to be read
    */

    public static final int START_GET_STATE_B=87;

     /** Constant designating the moment when the state of the object was read and the request is executed on the object
    */

    public static final int START_INVOKE=88;

     /** Constant designating the moment when the method corresponding to the request was invoked on the object, and the
     * reading of the update produced is read
	    */

    public static final int START_GET_STATE_A=89;

    /** Constant designating the moment when the (simulated) tentative execution of the request on the application object is
    * ended
    */

    public static final int STOP_TENT_EXEC = 90;

    /** Constant designating the moment when the leader initiates the consensus propose phase
    */

    public static final int START_CONSENSUS =91;

    /** Constant designating the moment when the consensus execution is ended
    */

    public static final int STOP_CONSENSUS=92;

    /** Constant designating the starting moment when (in case this is needed) the state read before method execution is restored
    * on the object
    */

    public static final int START_RESTORE_ST=93;

      /** Constant designating the moment when (in case this is needed) the restoration of the state read before method execution
	    * on the object is ended
    */

    public static final int STOP_RESTORE_ST=94;

     /** Constant designating the moment when the request processing on the object ends with an exception sending because this leader did
     * not manage to impose its result in the total order of method executions
    */

    public static final int STOP_PROC_EXC=95;

    /** Constant designating the moment when normal processing of the request on the application is ended
    */

    public static final int STOP_PROC_NORMAL=96;

    /** Constant designating the moment when the state of the object is restored even if the request processor replica was the leader, before
    * installing the update obtained from witnesses
    */
    public static final int SET_STATE=97;

     /** Constant designating the moment when installation of the update obtained from the witnesses is started
    */

    public static final int SET_UPDATE=98;

    /** Constant designating the moment when the update was installed on the application object
    */

    public static final int STOP_SET_UPDATE=99;

/** Constant used to establish the period with which the state record is sent to the witnesses when
* processing requests (of course, the periodicity is only approximate, since the transfer happens only
* after the server processes a request and the specified period passed; if, for example, the period is 5s,
* the server processed a request 10s ago when it sent the state, it will send the state again only now after 10s
* from the last sending of state, since in between it did not process any requests
*/

    public static final int PRUNE_PERIOD=10000; /* this value should be chenged to tune the period accordingly*/

/** Constant used to establish the number of requests to be processed before the leader has to send a state record
* over to the witnesses, as opposed to sending an update record and filling up the registers with those
*/
    public static final int PRUNE_PERIOD_NR_REQ=20;

    public static java.lang.Object BACKUP_SYNCH=new java.lang.Object();

    /* BEGIN general utilities*/

    public static org.omg.IIOP.ProfileBody_1_1 profile_body(ORB orb,TaggedProfile tp){
	org.omg.IIOP.ProfileBody_1_1 pb11=new org.omg.IIOP.ProfileBody_1_1();
	Any any;

	CodecFactory factory;
	Codec codec;
	if(tp==null) return null;

	try{
	    factory = (CodecFactory)orb.resolve_initial_references("CodecFactory");
	    codec = factory.create_codec(new Encoding(ENCODING_CDR_ENCAPS.value, (byte)1, (byte)2));
	    any=codec.decode_value(tp.profile_data,org.omg.IIOP.ProfileBody_1_1Helper.type());
	    pb11=org.omg.IIOP.ProfileBody_1_1Helper.extract(any);
	}catch(java.lang.Exception e){e.printStackTrace(new java.io.PrintStream(System.out));return null;}
	return pb11;
    }

    public static void print_IOR(ORB orb,IOR ior){
	int i;
	org.omg.IIOP.ProfileBody_1_1 pb11;

	for(i=0;i<ior.profiles.length;i++){
	    pb11=profile_body(orb,ior.profiles[i]);
	    System.out.println("Profile "+i+" data : "+pb11.host+":"+(int)pb11.port);
	}
    }


    public static void write_output_stream(org.omg.CORBA.Any any, org.omg.CORBA.portable.OutputStream os){
	try{
	    switch(any.type().kind().value()){

	    case org.omg.CORBA.TCKind._tk_abstract_interface:/*os.write_Object(any.extract_Object); */break;
	    case org.omg.CORBA.TCKind._tk_any:System.out.println("write any");os.write_any(any.extract_any());break;
	    case org.omg.CORBA.TCKind._tk_boolean:System.out.println("write boolean");os.write_boolean(any.extract_boolean());break;
	    case org.omg.CORBA.TCKind._tk_char:System.out.println("write char");os.write_char(any.extract_char());break;
	    case org.omg.CORBA.TCKind._tk_double:System.out.println("write double");os.write_double(any.extract_double());break;
	    case     org.omg.CORBA.TCKind._tk_long:System.out.println("write long");os.write_long(any.extract_long());break;
	    case org.omg.CORBA.TCKind._tk_float:System.out.println("write float");os.write_float(any.extract_float());break;
	    case     org.omg.CORBA.TCKind._tk_longlong:System.out.println("write longlong");os.write_longlong(any.extract_longlong());break;
	    case     org.omg.CORBA.TCKind._tk_octet:System.out.println("write octet");os.write_octet(any.extract_octet());break;
	    case     org.omg.CORBA.TCKind._tk_short :System.out.println("write short");os.write_short(any.extract_short()); break;
	    case     org.omg.CORBA.TCKind._tk_string:String theStr=any.extract_string();System.out.println("write string "+theStr);os.write_string(theStr);break;
	    case     org.omg.CORBA.TCKind._tk_TypeCode :System.out.println("write typecode");os.write_TypeCode(any.extract_TypeCode());break;
	    case     org.omg.CORBA.TCKind._tk_ulong :System.out.println("write ulong");os.write_ulong(any.extract_ulong());break;
	    case     org.omg.CORBA.TCKind._tk_ulonglong :System.out.println("write ulonglong");os.write_ulonglong(any.extract_ulonglong());break;
	    case    org.omg.CORBA.TCKind._tk_ushort :System.out.println("write ushort");os.write_ushort(any.extract_ushort());break;
	    case org.omg.CORBA.TCKind._tk_wchar:System.out.println("write wchar");os.write_wchar(any.extract_wchar());break;
	    case org.omg.CORBA.TCKind._tk_wstring:System.out.println("write wstring");os.write_wstring(any.extract_wstring());break;
	    case     org.omg.CORBA.TCKind._tk_Principal :System.out.println("write principal");os.write_Principal(any.extract_Principal());break;
	    case     org.omg.CORBA.TCKind._tk_sequence:System.out.println("write sequence");break;
	    case org.omg.CORBA.TCKind._tk_enum:
	    case      org.omg.CORBA.TCKind._tk_struct :
	    case     org.omg.CORBA.TCKind._tk_union :
	    case    org.omg.CORBA.TCKind._tk_value:
	    case org.omg.CORBA.TCKind._tk_array:
	    case org.omg.CORBA.TCKind._tk_value_box :
	    case org.omg.CORBA.TCKind._tk_except:
		System.out.println("write some struct");
		write_obj_extract(any,os);
		break;
	    case org.omg.CORBA.TCKind._tk_alias:
		System.out.println("recursive alias");

		org.omg.CORBA.TypeCode alias_typecode=any.type().content_type();
		if(alias_typecode.kind().value()!=org.omg.CORBA.TCKind._tk_sequence){
		    write_obj_helper_extract(any,os);
		    /*    any.type(any.type().content_type());
		    write_output_stream(any,os);
		    any.type(any.type());*/
		}
		else
		    write_obj_extract_seq(any,os,alias_typecode);
		break;
	    case org.omg.CORBA.TCKind._tk_fixed:System.out.println("write fixed");break;
	    case     org.omg.CORBA.TCKind._tk_longdouble:System.out.println("write longdouble");break;
	    case    org.omg.CORBA.TCKind._tk_native:System.out.println("write native");break;
	    case org.omg.CORBA.TCKind._tk_null:System.out.println("write null");break;
	    case org.omg.CORBA.TCKind._tk_objref:System.out.println("write corba Object");os.write_Object(any.extract_Object());break;
	    case org.omg.CORBA.TCKind._tk_void :System.out.println("write void");break;
	    }
	}catch(java.lang.Exception e){e.printStackTrace(new java.io.PrintStream(System.out));}
    }

    /*  public static void write_output_stream(org.omg.CORBA.Any any, org.omg.CORBA.portable.OutputStream os){
	try{
	    switch(any.type().kind().value()){

	    case org.omg.CORBA.TCKind._tk_abstract_interface:os.write_Object(any.extract_Object);break;
	    case org.omg.CORBA.TCKind._tk_any:universal.Debug.println("write any");os.write_any(any.extract_any());break;
	    case org.omg.CORBA.TCKind._tk_boolean:universal.Debug.println("write boolean");os.write_boolean(any.extract_boolean());break;
	    case org.omg.CORBA.TCKind._tk_char:universal.Debug.println("write char");os.write_char(any.extract_char());break;
	    case org.omg.CORBA.TCKind._tk_double:universal.Debug.println("write double");os.write_double(any.extract_double());break;
	    case     org.omg.CORBA.TCKind._tk_long:universal.Debug.println("write long");os.write_long(any.extract_long());break;
	    case org.omg.CORBA.TCKind._tk_float:universal.Debug.println("write float");os.write_float(any.extract_float());break;
	    case     org.omg.CORBA.TCKind._tk_longlong:universal.Debug.println("write longlong");os.write_longlong(any.extract_longlong());break;
	    case     org.omg.CORBA.TCKind._tk_octet:universal.Debug.println("write octet");os.write_octet(any.extract_octet());break;
	    case     org.omg.CORBA.TCKind._tk_short :universal.Debug.println("write short");os.write_short(any.extract_short()); break;
	    case     org.omg.CORBA.TCKind._tk_string:String theStr=any.extract_string();universal.Debug.println("write string "+theStr);os.write_string(theStr);break;
	    case     org.omg.CORBA.TCKind._tk_TypeCode :universal.Debug.println("write typecode");os.write_TypeCode(any.extract_TypeCode());break;
	    case     org.omg.CORBA.TCKind._tk_ulong :universal.Debug.println("write ulong");os.write_ulong(any.extract_ulong());break;
	    case     org.omg.CORBA.TCKind._tk_ulonglong :universal.Debug.println("write ulonglong");os.write_ulonglong(any.extract_ulonglong());break;
	    case    org.omg.CORBA.TCKind._tk_ushort :universal.Debug.println("write ushort");os.write_ushort(any.extract_ushort());break;
	    case org.omg.CORBA.TCKind._tk_wchar:universal.Debug.println("write wchar");os.write_wchar(any.extract_wchar());break;
	    case org.omg.CORBA.TCKind._tk_wstring:universal.Debug.println("write wstring");os.write_wstring(any.extract_wstring());break;
	    case     org.omg.CORBA.TCKind._tk_Principal :universal.Debug.println("write principal");os.write_Principal(any.extract_Principal());break;
	    case     org.omg.CORBA.TCKind._tk_sequence:universal.Debug.println("write sequence");break;
	    case org.omg.CORBA.TCKind._tk_enum:
	    case      org.omg.CORBA.TCKind._tk_struct :
	    case     org.omg.CORBA.TCKind._tk_union :
	    case    org.omg.CORBA.TCKind._tk_value:
	    case org.omg.CORBA.TCKind._tk_array:
	    case org.omg.CORBA.TCKind._tk_value_box :
	    case org.omg.CORBA.TCKind._tk_except:
		universal.Debug.println("write some struct");
		write_obj_extract(any,os);
		break;
	    case org.omg.CORBA.TCKind._tk_alias:
		universal.Debug.println("recursive alias");
		System.out.println("the id is "+any.type().id());
		org.omg.CORBA.TypeCode alias_typecode=any.type().content_type();
		if(alias_typecode.kind().value()!=org.omg.CORBA.TCKind._tk_sequence){
		    any.type(any.type().content_type());
		    write_output_stream(any,os);
		    any.type(any.type());
		}
		else
		    write_obj_extract_seq(any,os,alias_typecode);
		break;
	    case org.omg.CORBA.TCKind._tk_fixed:universal.Debug.println("write fixed");break;
	    case     org.omg.CORBA.TCKind._tk_longdouble:universal.Debug.println("write longdouble");break;
	    case    org.omg.CORBA.TCKind._tk_native:universal.Debug.println("write native");break;
	    case org.omg.CORBA.TCKind._tk_null:universal.Debug.println("write null");break;
	    case org.omg.CORBA.TCKind._tk_objref:universal.Debug.println("write corba Object");os.write_Object(any.extract_Object());break;
	    case org.omg.CORBA.TCKind._tk_void :universal.Debug.println("write void");break;
	    }
	}catch(java.lang.Exception e){e.printStackTrace(new java.io.PrintStream(System.out));}
	}*/

    /* END general utilities*/

     /* BEGIN NamingService utilities*/

    public static org.omg.CosNaming.NamingContext resolve_n(org.omg.CosNaming.NamingContext ncx,org.omg.CosNaming.NameComponent[] ncs){
	org.omg.CORBA.Object reto=null;
	org.omg.CosNaming.NamingContext ret=null;
	try{
	    reto=ncx.resolve(ncs);
	    ret=org.omg.CosNaming.NamingContextHelper.narrow(reto);
	}catch(org.omg.CosNaming.NamingContextPackage.InvalidName e){return null;}
	catch(org.omg.CosNaming.NamingContextPackage.NotFound e){return null;}
	catch(org.omg.CosNaming.NamingContextPackage.CannotProceed e){return null;}
	return ret;
    }

    public static org.omg.CosNaming.NamingContext bind_context(org.omg.CosNaming.NamingContext ncx,org.omg.CosNaming.NameComponent[] ncs){
	org.omg.CosNaming.NamingContext ret=null;
	try{
	    ret=ncx.bind_new_context(ncs);
	}catch(org.omg.CosNaming.NamingContextPackage.AlreadyBound e){return null;}
	catch(org.omg.CosNaming.NamingContextPackage.InvalidName e){return null;}
	catch(org.omg.CosNaming.NamingContextPackage.NotFound e){return null;}
	catch(org.omg.CosNaming.NamingContextPackage.CannotProceed e){return null;}
	return ret;
    }

    /* END NamingService utilities*/



    public static java.lang.Class get_class(String type_id){
	java.lang.Class toRet=null;
	String class_n=null;
	StringBuffer class_n_b=null;
	try{
	    class_n=get_class_name(type_id);
	    int i=class_n.lastIndexOf('.');
	    class_n_b=new StringBuffer(class_n);
	    class_n_b.insert(i+1,'_');
	    class_n_b.append("Stub");
	    toRet=java.lang.Class.forName(class_n_b.toString());
	}catch(java.lang.Exception e){e.printStackTrace(new java.io.PrintStream(System.out));toRet=null;}
	return toRet;
    }

    public static String get_class_helper(String type_id){
	if(type_id==null) return "";
	return get_class_name(type_id)+"Helper";
    }

    public static String get_class_helper_s(String class_n){
	return class_n+"Helper";
    }

    public static String get_class_name(String type_id){
	int i,j;
	StringTokenizer path,part_path;
	String part_token;
	StringBuffer toRet=new StringBuffer();

	if(type_id==null) return "";

	i=type_id.indexOf(":");
	j=type_id.indexOf(":",i+1);
	//	System.out.println(type_id.substring(i+1,j));
	path=new StringTokenizer(type_id.substring(i+1,j),"/");
	while(path.hasMoreTokens()){
	    part_token=path.nextToken();
	    // System.out.println(part_token);
	    if(part_token.indexOf('.')!=-1){
		part_path=new StringTokenizer(part_token,".");
		while(part_path.hasMoreTokens()){
		    toRet.insert(0,part_path.nextToken());
		    if(part_path.hasMoreTokens()) toRet.insert(0,'.');
		    else if(path.hasMoreTokens()) toRet.append('.');
		}
	    }
	    else{
		toRet.append(part_token);
		if(path.hasMoreTokens()) toRet.append('.');
	    }
	}
	return toRet.toString();
    }

    public static void write_obj_extract(org.omg.CORBA.Any any,org.omg.CORBA.portable.OutputStream os){
	String class_n;
	String helper;
	Class helper_class,param_cl[];
	java.lang.reflect.Method os_write_m,extract_method;
	java.lang.Object params[],result,helper_class_inst;
	try{
	    class_n=get_class_name(any.type().id());
	    helper=get_class_helper_s(class_n);
	    helper_class=Class.forName(helper);
	    helper_class_inst=helper_class.newInstance();
	    param_cl=new Class[1];
	    param_cl[0]=Class.forName("org.omg.CORBA.Any");
	    extract_method=helper_class.getMethod("extract",param_cl);
	    params=new java.lang.Object[1];
	    params[0]=any;
	    result=extract_method.invoke(helper_class_inst,params);
	    param_cl=new Class[2];
	    param_cl[0]=Class.forName("org.omg.CORBA.portable.OutputStream");
	    param_cl[1]=Class.forName(class_n);
	    os_write_m=helper_class.getMethod("write",param_cl);
	    params=new java.lang.Object[2];
	    params[0]=(java.lang.Object)os;
	    params[1]=result;
	    os_write_m.invoke(helper_class_inst,params);
	}catch(java.lang.Exception e){e.printStackTrace(new java.io.PrintStream(System.out));}
    }

    public static void write_obj_extract_seq(org.omg.CORBA.Any any,org.omg.CORBA.portable.OutputStream os,org.omg.CORBA.TypeCode seq_tc){
	String class_n,seq_cl_n;
	String seq_el_id;
	String helper;
	Class helper_class,param_cl[];
	java.lang.reflect.Method os_write_m,extract_method;
	java.lang.Object params[],result,helper_class_inst;
	try{
	    class_n=get_class_name(any.type().id());
	    seq_cl_n="[L"+get_class_name(seq_tc.content_type().id())+";";
	    helper=get_class_helper_s(class_n);
	    helper_class=Class.forName(helper);
	    helper_class_inst=helper_class.newInstance();
	    param_cl=new Class[1];
	    param_cl[0]=Class.forName("org.omg.CORBA.Any");
	    extract_method=helper_class.getMethod("extract",param_cl);
	    params=new java.lang.Object[1];
	    params[0]=any;
	    result=extract_method.invoke(helper_class_inst,params);
	    param_cl=new Class[2];
	    param_cl[0]=Class.forName("org.omg.CORBA.portable.OutputStream");
	    param_cl[1]=Class.forName(seq_cl_n);
	    os_write_m=helper_class.getMethod("write",param_cl);
	    params=new java.lang.Object[2];
	    params[0]=(java.lang.Object)os;
	    params[1]=result;
	    os_write_m.invoke(helper_class_inst,params);
	}catch(java.lang.Exception e){e.printStackTrace(new java.io.PrintStream(System.out));}
    }


        public static void write_obj_helper_extract(org.omg.CORBA.Any any,org.omg.CORBA.portable.OutputStream os){
	String class_n;
	String helper;
	StringBuffer corrector=null;
	Class helper_class,param_cl[];
	java.lang.reflect.Method os_write_m=null,extract_method;
	java.lang.Object params[],result,helper_class_inst;
	try{
	    class_n=get_class_name(any.type().id());
	    helper=get_class_helper_s(class_n);
	    try{
		helper_class=Class.forName(helper);
	    }catch(java.lang.ClassNotFoundException e){
		int k=helper.lastIndexOf(".");
		corrector=new StringBuffer(helper.substring(0,k));
		corrector=corrector.append("Package."+helper.substring(k+1));
		helper=corrector.toString();
		System.out.println("Corrected helper name is "+helper);
		helper_class=Class.forName(helper);
	    }
	    helper_class_inst=helper_class.newInstance();
	    param_cl=new Class[1];
	    param_cl[0]=Class.forName("org.omg.CORBA.Any");
	    extract_method=helper_class.getMethod("extract",param_cl);
	    params=new java.lang.Object[1];
	    params[0]=any;
	    result=extract_method.invoke(helper_class_inst,params);
	    /*param_cl=new Class[2];
	      param_cl[0]=Class.forName("org.omg.CORBA.portable.OutputStream");
	      param_cl[1]=result.getClass();
	    */
	    java.lang.reflect.Method[] methods=helper_class.getMethods();
	    for(int i=0;i<methods.length;i++)
		if(methods[i].getName().equals("write")){
		    os_write_m=methods[i];
		    break;
		}
	    params=new java.lang.Object[2];
	    params[0]=(java.lang.Object)os;
	    params[1]=result;
	    //System.out.println((Long)result);
	    if(os_write_m!=null)
		os_write_m.invoke(helper_class_inst,params);
	    else
		System.out.println("OOpps!! Is null write");
	}catch(java.lang.Exception e){e.printStackTrace(new java.io.PrintStream(System.out));}
    }

 public static void read_input_stream(org.omg.CORBA.portable.InputStream input,org.omg.CORBA.Any guide,boolean typecode_only){
	int to_switch;
	org.omg.CORBA.TypeCode its_typecode=null,alias_typecode=null;
	try{
	    if(typecode_only){
		if(guide.type().kind().value()!=org.omg.CORBA.TCKind._tk_TypeCode) {universal.Debug.println("no read");return;}
		its_typecode=guide.extract_TypeCode();
	    }
	    else
		its_typecode=guide.type();
	    to_switch=its_typecode.kind().value();
	    switch(to_switch){
	    case org.omg.CORBA.TCKind._tk_abstract_interface:/*os.write_Object(any.extract_Object); */break;
	    case org.omg.CORBA.TCKind._tk_alias://universal.Debug.println("read insert alias");
		alias_typecode=its_typecode.content_type();
		if(alias_typecode.kind().value()!=org.omg.CORBA.TCKind._tk_sequence){
		    guide.insert_TypeCode(alias_typecode);
		    read_input_stream(input,guide,true);
		}
		else{
		    if(typecode_only)
			guide.type(its_typecode);
		    insert_obj_read_seq(guide,input,alias_typecode);
		    if(guide.type().kind().value()==org.omg.CORBA.TCKind._tk_sequence)
			universal.Debug.println("It is sequence");
		    else
			if(guide.type().kind().value()==org.omg.CORBA.TCKind._tk_alias)
			    universal.Debug.println("It is alias");
			else
			    universal.Debug.println("It is something else");
		}
		break;
	    case org.omg.CORBA.TCKind._tk_any:/*universal.Debug.println("read insert any");*/org.omg.CORBA.Any any=input.read_any();guide.insert_any(any);break;
	    case org.omg.CORBA.TCKind._tk_array:universal.Debug.println("read insert array");break;
	    case org.omg.CORBA.TCKind._tk_boolean:/*universal.Debug.println("read insert boolean");*/boolean b=input.read_boolean();guide.insert_boolean(b);/*universal.Debug.println("read insert boolean");*/break;
	    case org.omg.CORBA.TCKind._tk_char:/*universal.Debug.println("read insert char");*/char c=input.read_char();guide.insert_char(c);/*universal.Debug.println("read insert char");*/break;
	    case org.omg.CORBA.TCKind._tk_double:/*universal.Debug.println("read insert double");*/double d=input.read_double();guide.insert_double(d);/*universal.Debug.println("read insert double");*/break;
	    case org.omg.CORBA.TCKind._tk_except:/*universal.Debug.println("read insert except");*/break;
	    case org.omg.CORBA.TCKind._tk_fixed:/*universal.Debug.println("read insert fixed");*/break;
	    case org.omg.CORBA.TCKind._tk_float:/*universal.Debug.println("read insert float");*/float f=input.read_float();guide.insert_float(f);break;
		//    case     org.omg.CORBA.TCKind._tk_local_interface:return null;
	    case org.omg.CORBA.TCKind._tk_long:/*universal.Debug.println("read insert int");*/int l=input.read_long();guide.insert_long(l);break;
	    case org.omg.CORBA.TCKind._tk_longdouble:/*universal.Debug.println("read insert longdouble");*/break;
	    case org.omg.CORBA.TCKind._tk_longlong:/*universal.Debug.println("read insert long");*/
		long ll=input.read_longlong();guide.insert_longlong(ll);break;
	    case org.omg.CORBA.TCKind._tk_null:/*universal.Debug.println("read insert null");*/
		break;
	    case org.omg.CORBA.TCKind._tk_objref:
		//universal.Debug.println("read insert objref");
		universal.Debug.println(its_typecode.id());
		//java.lang.Class cl=get_class(its_typecode.id());
		//universal.Debug.println(cl.getName());
		org.omg.CORBA.Object obj=input.read_Object();
		guide.insert_Object(obj);
		break;
	    case org.omg.CORBA.TCKind._tk_octet://universal.Debug.println("read insert byte");
		byte by=input.read_octet();guide.insert_octet(by);break;
	    case org.omg.CORBA.TCKind._tk_Principal ://universal.Debug.println("read insert pr");
		break;
	    case org.omg.CORBA.TCKind._tk_sequence:universal.Debug.println("read insert seq");
		/*	if(typecode_only==true)
		    guide.type(its_typecode);
		    insert_obj_read(guide,input);*/
		break;
	    case org.omg.CORBA.TCKind._tk_short ://universal.Debug.println("read insert short");
		short s=input.read_short();guide.insert_short(s); break;
	    case    org.omg.CORBA.TCKind._tk_string://universal.Debug.println("read insert string");
		String str=input.read_string();guide.insert_string(str);break;
	    case      org.omg.CORBA.TCKind._tk_struct :
	    case org.omg.CORBA.TCKind._tk_enum:
	    case     org.omg.CORBA.TCKind._tk_union :
	    case    org.omg.CORBA.TCKind._tk_value:
	    case org.omg.CORBA.TCKind._tk_value_box :
	    case org.omg.CORBA.TCKind._tk_native:
		//universal.Debug.println("read insert some struct");
		if(typecode_only==true)
		    guide.type(its_typecode);
		insert_obj_read(guide,input);
		break;
	    case     org.omg.CORBA.TCKind._tk_TypeCode ://universal.Debug.println("read insert type_code");
		org.omg.CORBA.TypeCode tc=input.read_TypeCode();guide.insert_TypeCode(tc);break;
	    case     org.omg.CORBA.TCKind._tk_ulong ://universal.Debug.println("read insert uint");
		int ul=input.read_ulong();guide.insert_ulong(ul);break;
	    case     org.omg.CORBA.TCKind._tk_ulonglong ://universal.Debug.println("read insert ulong");
		long ull=input.read_ulonglong();guide.insert_ulonglong(ull);break;
	    case    org.omg.CORBA.TCKind._tk_ushort ://universal.Debug.println("read insert ushort");
		short us=input.read_ushort();guide.insert_ushort(us);break;
	    case org.omg.CORBA.TCKind._tk_void ://universal.Debug.println("read insert void");
		break;
	    case org.omg.CORBA.TCKind._tk_wchar://universal.Debug.println("read insert wchar");
		char wc=input.read_wchar();guide.insert_wchar(wc);break;
	    case org.omg.CORBA.TCKind._tk_wstring://universal.Debug.println("read insert wstring");
		String wstr=input.read_wstring();guide.insert_wstring(wstr);break;
	    }
	}catch(java.lang.Exception e){universal.Debug.println("Exception in read_inpout_stream");e.printStackTrace(new java.io.PrintStream(System.out));universal.Debug.println("Exception in read_input_stream");}
    }
 public static void insert_obj_read(org.omg.CORBA.Any any,org.omg.CORBA.portable.InputStream input){
	String class_n;
	String helper;
	Class helper_class,param_cl[];
	java.lang.reflect.Method is_read_m,insert_method;
	java.lang.Object params[],result,helper_class_inst;
	try{
	    class_n=get_class_name(any.type().id());
	    helper=get_class_helper_s(class_n);
	    helper_class=Class.forName(helper);
	    helper_class_inst=helper_class.newInstance();
	    param_cl=new Class[1];
	    param_cl[0]=Class.forName("org.omg.CORBA.portable.InputStream");
	    is_read_m=helper_class.getMethod("read",param_cl);
	    param_cl=new Class[2];
	    param_cl[0]=Class.forName("org.omg.CORBA.Any");
	    param_cl[1]=Class.forName(class_n);
	    insert_method=helper_class.getMethod("insert",param_cl);
	    params=new java.lang.Object[1];
	    params[0]=input;
	    result=is_read_m.invoke(helper_class_inst,params);
	    params=new java.lang.Object[2];
	    params[0]=any;
	    params[1]=result;
	    insert_method.invoke(helper_class_inst,params);
	}catch(java.lang.Exception e){e.printStackTrace(new java.io.PrintStream(System.out));}
    }

    public static void insert_obj_read_seq(org.omg.CORBA.Any any,org.omg.CORBA.portable.InputStream input,org.omg.CORBA.TypeCode seq_tc){
	String class_n,seq_class_n;
	String helper;
	Class helper_class,param_cl[];
	java.lang.reflect.Method is_read_m,insert_method;
	java.lang.Object params[],result,helper_class_inst;
	org.omg.CORBA.TypeCode any_tc,seq_e_typecode;
	String the_seq_id;
	try{
	    any_tc=any.type();
	    seq_e_typecode=seq_tc.content_type();
	    the_seq_id=any_tc.id();
	    class_n=get_class_name(the_seq_id);
	    helper=get_class_helper_s(class_n);
	    helper_class=Class.forName(helper);
	    helper_class_inst=helper_class.newInstance();
	    param_cl=new Class[1];
	    param_cl[0]=Class.forName("org.omg.CORBA.portable.InputStream");
	    is_read_m=helper_class.getMethod("read",param_cl);
	    param_cl=new Class[2];
	    param_cl[0]=Class.forName("org.omg.CORBA.Any");
	    seq_class_n="[L"+get_class_name(seq_e_typecode.id())+";";
	    param_cl[1]=Class.forName(seq_class_n);
	    insert_method=helper_class.getMethod("insert",param_cl);
	    params=new java.lang.Object[1];
	    params[0]=input;
	    result=is_read_m.invoke(helper_class_inst,params);
	    params=new java.lang.Object[2];
	    params[0]=any;
	    params[1]=result;
	    insert_method.invoke(helper_class_inst,params);
	    //any.type(seq_tc);
	    if(any.type().kind().value()==org.omg.CORBA.TCKind._tk_sequence)
		universal.Debug.println("It is sequence in meth read_seq");
	    else
		if(any.type().kind().value()==org.omg.CORBA.TCKind._tk_alias)
		    universal.Debug.println("It is alias in meth read_seq");
		else
		    universal.Debug.println("It is something else in meth read_seq");
	}catch(java.lang.Exception e){e.printStackTrace(new java.io.PrintStream(System.out));}
    }
public static java.lang.Object read_param(org.omg.CORBA.portable.InputStream input,String type){
	if(type.equals("java.lang.Integer")||type.equals("int"))
	    return new java.lang.Integer(input.read_long());
	if(type.equals("java.lang.Long")||type.equals("long"))
	    return new java.lang.Long(input.read_longlong());
	if(type.equals("java.lang.Boolean")||type.equals("boolean"))
	    return new java.lang.Boolean(input.read_boolean());
	if(type.equals("java.lang.String"))
	    return new java.lang.String(input.read_string());
	if(type.equals("java.lang.Character")||type.equals("char"))
	    return new java.lang.Character(input.read_char());
	if(type.equals("java.lang.Short")||type.equals("short"))
	    return new java.lang.Short(input.read_short());
	if(type.equals("java.lang.Float")||type.equals("float"))
	    return new java.lang.Float(input.read_float());
	if(type.equals("java.lang.Double")||type.equals("double"))
	    return new java.lang.Double(input.read_double());
	if(type.equals("org.omg.CORBA.Any"))
	    return input.read_any();
	if(type.equals("org.omg.CORBA.Object"))
	    return input.read_Object();
	return new java.lang.Object();
    }

    public static org.omg.Dynamic.Parameter[] read_args(org.omg.CORBA.ORB orb,universal.MethSignStr method_s,org.openorb.iiop.CDRInputStream is) throws org.omg.CORBA.BAD_PARAM{

	int i;
	org.omg.Dynamic.Parameter[] toRet;
	org.omg.CORBA.Any guide;
	org.omg.CORBA.TypeCode[] param_type_codes=method_s.param_types;
	int[] modes=method_s.param_modes;
	toRet=new org.omg.Dynamic.Parameter[modes.length];
	for(i=0;i<modes.length;i++){
	    guide=orb.create_any();
	     guide.insert_TypeCode(param_type_codes[i]);
	     if(modes[i]!=org.omg.CORBA.ParameterMode._PARAM_OUT)
		 read_input_stream(is,guide,true);
	     //write_output_stream(guide,fake_stream);
	     toRet[i]=new org.omg.Dynamic.Parameter(guide,org.omg.CORBA.ParameterMode.from_int(modes[i]));
	}
	return toRet;
    }
   public static java.lang.Object give_object(org.omg.CORBA.Any any){

	switch(any.type().kind().value()){
	case org.omg.CORBA.TCKind._tk_abstract_interface:return null;
	case org.omg.CORBA.TCKind._tk_alias:
	    /*org.omg.CORBA.TypeCode aliasl_typecode;
	      alias_typecode=any.type().content_type();
	      if(alias_typecode.kind().value()!=org.omg.CORBA.TCKind._tk_sequence){
	      any.insert_TypeCode(alias_typecode);
	      read_input_stream(input,guide,true);
	      }
	      else{
	      if(typecode_only)
	      guide.type(alias_typecode);
	      insert_obj_read_seq(guide,input,its_typecode);
	      }*/
	    universal.Debug.println("give  obj from Alias tc");
	    return extract_obj_from_any(any);
	case     org.omg.CORBA.TCKind._tk_any:return (java.lang.Object)(any.extract_any());
	case     org.omg.CORBA.TCKind._tk_boolean:return new java.lang.Boolean(any.extract_boolean());
	case     org.omg.CORBA.TCKind._tk_char:return new java.lang.Character(any.extract_char());
	case     org.omg.CORBA.TCKind._tk_double:return new java.lang.Double(any.extract_double());
	case     org.omg.CORBA.TCKind._tk_fixed:return null;
	case     org.omg.CORBA.TCKind._tk_float:return new java.lang.Float(any.extract_float());
	    //    case     org.omg.CORBA.TCKind._tk_local_interface:return null;
	case     org.omg.CORBA.TCKind._tk_long:return new java.lang.Integer(any.extract_long());
	case     org.omg.CORBA.TCKind._tk_longdouble:return new java.lang.Double(any.extract_double());
	case     org.omg.CORBA.TCKind._tk_longlong:return new java.lang.Long(any.extract_longlong());
	case    org.omg.CORBA.TCKind._tk_native:return null;
	case org.omg.CORBA.TCKind._tk_null:return null;
	case org.omg.CORBA.TCKind._tk_objref:return null;
	case     org.omg.CORBA.TCKind._tk_octet:return new java.lang.Byte(any.extract_octet());
	case     org.omg.CORBA.TCKind._tk_Principal :return null;
	case     org.omg.CORBA.TCKind._tk_union :universal.Debug.println("tk_union");return extract_obj_from_any(any);
	case      org.omg.CORBA.TCKind._tk_struct :universal.Debug.println("tk_struct");return extract_obj_from_any(any);
	case     org.omg.CORBA.TCKind._tk_sequence:universal.Debug.println("tk_sequence");return extract_obj_from_any(any);
	case     org.omg.CORBA.TCKind._tk_array:universal.Debug.println("tk_array");return extract_obj_from_any(any);
	case     org.omg.CORBA.TCKind._tk_except:universal.Debug.println("tk_except");return extract_obj_from_any(any);
	case     org.omg.CORBA.TCKind._tk_enum:universal.Debug.println("tk_enum");return extract_obj_from_any(any);
	case     org.omg.CORBA.TCKind._tk_short :return new java.lang.Short(any.extract_short());
	case     org.omg.CORBA.TCKind._tk_string:return any.extract_string();
	case     org.omg.CORBA.TCKind._tk_TypeCode :return any.extract_TypeCode();
	case     org.omg.CORBA.TCKind._tk_ulong :return new java.lang.Integer(any.extract_ulong());
	case     org.omg.CORBA.TCKind._tk_ulonglong :return new java.lang.Long(any.extract_ulonglong());
	case    org.omg.CORBA.TCKind._tk_ushort :return new java.lang.Short(any.extract_ushort());
	case    org.omg.CORBA.TCKind._tk_value:return null;
	case org.omg.CORBA.TCKind._tk_value_box :return null;
	case org.omg.CORBA.TCKind._tk_void :return null;
	case org.omg.CORBA.TCKind._tk_wchar:return new java.lang.Character(any.extract_wchar());
	case org.omg.CORBA.TCKind._tk_wstring:return any.extract_wstring();
	}
	return null;
    }
 public static java.lang.Object holder_with_value(org.omg.CORBA.Any any,boolean typecode_only){

	String class_n;
	String helper;
	Class helper_class,param_cl[];
	java.lang.reflect.Field value_field;
	java.lang.reflect.Method os_write_m,extract_method;
	java.lang.Object params[],result=null,helper_class_inst,holder_class_inst;
	try{
	    class_n=get_class_name(any.type().id());
	    helper=get_class_helper_s(class_n);
	    helper_class=Class.forName(helper);
	    helper_class_inst=helper_class.newInstance();
	    param_cl=new Class[1];
	    param_cl[0]=Class.forName("org.omg.CORBA.Any");
	    extract_method=helper_class.getMethod("extract",param_cl);
	    params=new java.lang.Object[1];
	    params[0]=any;
	    result=extract_method.invoke(helper_class_inst,params);
	    holder_class_inst=Class.forName(class_n+"Holder").newInstance();
	    if(!typecode_only){
		value_field=Class.forName(class_n+"Holder").getField("value");
		value_field.set(holder_class_inst,result);
	    }
	}catch(java.lang.Exception e){e.printStackTrace(new java.io.PrintStream(System.out));return null;}

	return holder_class_inst;
    }
 public static java.lang.Object give_object_holder(org.omg.CORBA.Any any,boolean typecode_only){
	   int to_switch;
	   universal.Debug.println("Give object holder");
	   try{
	       if(typecode_only){
		   if(any.type().kind().value()!=org.omg.CORBA.TCKind._tk_TypeCode) {universal.Debug.println("no read");return null;}
		   to_switch=any.extract_TypeCode().kind().value();
	       }
	       else
		   to_switch=any.type().kind().value();
	       switch(to_switch){

	       case org.omg.CORBA.TCKind._tk_abstract_interface:return null;

	       case org.omg.CORBA.TCKind._tk_alias:return null;

	       case     org.omg.CORBA.TCKind._tk_any:
		   if(typecode_only)
		       return new org.omg.CORBA.AnyHolder();
		   return new org.omg.CORBA.AnyHolder(any.extract_any());
	       case     org.omg.CORBA.TCKind._tk_boolean:
		   if(typecode_only)
		       return new org.omg.CORBA.BooleanHolder();
		   return new org.omg.CORBA.BooleanHolder(any.extract_boolean());

	       case     org.omg.CORBA.TCKind._tk_char:
		   if(typecode_only)
		       return new org.omg.CORBA.CharHolder();
		   return new org.omg.CORBA.CharHolder(any.extract_char());

	       case     org.omg.CORBA.TCKind._tk_double:
		   if(typecode_only)
		       return new org.omg.CORBA.DoubleHolder();
		   return new org.omg.CORBA.DoubleHolder(any.extract_double());





	       case     org.omg.CORBA.TCKind._tk_fixed:return null;

	       case     org.omg.CORBA.TCKind._tk_float:
		      if(typecode_only)
			  return new org.omg.CORBA.FloatHolder();
		      return new org.omg.CORBA.FloatHolder(any.extract_float());

		      //    case     org.omg.CORBA.TCKind._tk_local_interface:return null;

	       case     org.omg.CORBA.TCKind._tk_long:
		   if(typecode_only)
		       return new org.omg.CORBA.IntHolder();
		   return new org.omg.CORBA.IntHolder(any.extract_long());

	       case     org.omg.CORBA.TCKind._tk_longdouble:return null;

	       case     org.omg.CORBA.TCKind._tk_longlong:
		   if(typecode_only)
		       return new org.omg.CORBA.LongHolder();
		   return new org.omg.CORBA.LongHolder(any.extract_longlong());

	       case    org.omg.CORBA.TCKind._tk_native:return null;

	       case org.omg.CORBA.TCKind._tk_null:return null;

	       case org.omg.CORBA.TCKind._tk_objref:return any.extract_Object();

	       case     org.omg.CORBA.TCKind._tk_octet:
		   if(typecode_only)
		       return new org.omg.CORBA.ByteHolder();
		   return new org.omg.CORBA.ByteHolder(any.extract_octet());

	       case     org.omg.CORBA.TCKind._tk_Principal :return null;
	       case     org.omg.CORBA.TCKind._tk_enum:
	       case     org.omg.CORBA.TCKind._tk_union :
	       case      org.omg.CORBA.TCKind._tk_struct :
	       case     org.omg.CORBA.TCKind._tk_sequence:
	       case     org.omg.CORBA.TCKind._tk_array:
	       case     org.omg.CORBA.TCKind._tk_except:
		   return holder_with_value(any,typecode_only);

	       case     org.omg.CORBA.TCKind._tk_short :
		   if(typecode_only)
		       return new org.omg.CORBA.ShortHolder();
		   return new org.omg.CORBA.ShortHolder(any.extract_short());

	       case     org.omg.CORBA.TCKind._tk_string:
		   if(typecode_only)
		       return new org.omg.CORBA.StringHolder();
		   return new org.omg.CORBA.StringHolder(any.extract_string());


	       case     org.omg.CORBA.TCKind._tk_TypeCode :
		   if(typecode_only)
		       return new org.omg.CORBA.TypeCodeHolder();
		   return new org.omg.CORBA.TypeCodeHolder(any.extract_TypeCode());

	       case     org.omg.CORBA.TCKind._tk_ulong :
		   if(typecode_only)
		       return new org.omg.CORBA.IntHolder();
		   return new org.omg.CORBA.IntHolder(any.extract_ulong());

	       case     org.omg.CORBA.TCKind._tk_ulonglong :
		   if(typecode_only)
		       return new org.omg.CORBA.LongHolder();
		   return new org.omg.CORBA.LongHolder(any.extract_ulonglong());



	       case    org.omg.CORBA.TCKind._tk_ushort :
		      if(typecode_only)
			  return new org.omg.CORBA.ShortHolder();
		   return new org.omg.CORBA.ShortHolder(any.extract_ushort());

	       case    org.omg.CORBA.TCKind._tk_value:return null;

	       case org.omg.CORBA.TCKind._tk_value_box :return null;

	       case org.omg.CORBA.TCKind._tk_void :return null;

	       case org.omg.CORBA.TCKind._tk_wchar:return null;

	       case org.omg.CORBA.TCKind._tk_wstring:
		   if(typecode_only)
		       return new org.omg.CORBA.StringHolder();
		   return new org.omg.CORBA.StringHolder(any.extract_wstring());
	       }
	   }catch(java.lang.Exception e){e.printStackTrace();}
	   return null;
       }



    public static java.lang.Object extract_obj_from_any(org.omg.CORBA.Any any){
	String helper;
	Class helper_class,param_cl[];
	java.lang.reflect.Method os_write_m,extract_method;
	java.lang.Object params[],result,helper_class_inst;
	try{
	    helper=get_class_helper(any.type().id());
	    helper_class=Class.forName(helper);
	    helper_class_inst=helper_class.newInstance();
	    param_cl=new Class[1];
	    param_cl[0]=Class.forName("org.omg.CORBA.Any");
	    extract_method=helper_class.getMethod("extract",param_cl);
	    params=new java.lang.Object[1];
	    params[0]=any;
	    result=extract_method.invoke(helper_class_inst,params);
	}catch(java.lang.Exception e){e.printStackTrace(new java.io.PrintStream(System.out));return null;}
	return result;
    }
public static org.omg.CORBA.Any give_any(org.omg.CORBA.ORB orb,java.lang.Object result,boolean holder){
	org.omg.CORBA.Any any=orb.create_any();
	String type;
	java.lang.Object value;
	try{
	    if(result==null) {any.insert_TypeCode(orb.get_primitive_tc(org.omg.CORBA.TCKind.tk_void));return any;}
	    if(holder){
		value=result.getClass().getField("value").get(result);
		type=value.getClass().getName();
	    }
	    else{
		type=result.getClass().getName();
		value=result;
	    }
	    if(type.equals("java.lang.Integer")||type.equals("int"))
		any.insert_long(((java.lang.Integer)value).intValue());
	    if(type.equals("java.lang.Long")||type.equals("long"))
		any.insert_longlong(((java.lang.Long)value).longValue());
	    if(type.equals("java.lang.Boolean")||type.equals("boolean"))
		any.insert_boolean(((java.lang.Boolean)value).booleanValue());
	    if(type.equals("java.lang.String"))
		any.insert_string(((java.lang.String)value).toString());
	    if(type.equals("java.lang.Character")||type.equals("char"))
		any.insert_char(((java.lang.Character)value).charValue());
	    if(type.equals("java.lang.Short")||type.equals("short"))
		any.insert_short(((java.lang.Short)value).shortValue());
	    if(type.equals("java.lang.Float")||type.equals("float"))
		any.insert_float(((java.lang.Float)value).floatValue());
	    if(type.equals("java.lang.Double")||type.equals("double"))
		any.insert_double(((java.lang.Double)value).doubleValue());
	    if(type.equals("[B"))
		org.omg.CORBA.OctetSeqHelper.insert(any,(byte[])value);
	    if(type.equals("[I"))
		org.omg.CORBA.LongSeqHelper.insert(any,(int[])value);
	    if(type.equals("[J"))
		org.omg.CORBA.LongLongSeqHelper.insert(any,(long[])value);
	    if(type.equals("[Z"))
		org.omg.CORBA.BooleanSeqHelper.insert(any,(boolean[])value);
	    if(type.equals("[S"))
		org.omg.CORBA.ShortSeqHelper.insert(any,(short[])value);
	    if(type.equals("[C"))
		org.omg.CORBA.CharSeqHelper.insert(any,(char[])value);
	    if(type.equals("[F"))
		org.omg.CORBA.FloatSeqHelper.insert(any,(float[])value);
	    if(type.equals("[D"))
		org.omg.CORBA.DoubleSeqHelper.insert(any,(double[])value);
	    if(type.equals("[Ljava.lang.String;"))
		org.omg.CORBA.StringSeqHelper.insert(any,(String[])value);
	    if(type.equals("org.omg.CORBA.Any"))
		any.insert_any((org.omg.CORBA.Any)value);
	    if(type.equals("org.omg.CORBA.Object"))
		any.insert_Object((org.omg.CORBA.Object)value);
	}catch(java.lang.Exception e){e.printStackTrace();return null;}
	return any;
    }
public static org.omg.CORBA.Any give_any_arg(org.omg.CORBA.ORB orb,java.lang.Object value){
	org.omg.CORBA.Any any=orb.create_any();
	String type;

	try{


		type=value.getClass().getName();

	    if(type.equals("java.lang.Integer")||type.equals("int"))
		{

		    any.insert_long(((java.lang.Integer)value).intValue());

		}
	    if(type.equals("java.lang.Long")||type.equals("long"))
		any.insert_longlong(((java.lang.Long)value).longValue());
	    if(type.equals("java.lang.Boolean")||type.equals("boolean"))
		any.insert_boolean(((java.lang.Boolean)value).booleanValue());
	    if(type.equals("java.lang.String"))
		any.insert_string(((java.lang.String)value).toString());
	    if(type.equals("java.lang.Character")||type.equals("char"))
		any.insert_char(((java.lang.Character)value).charValue());
	    if(type.equals("java.lang.Short")||type.equals("short"))
		any.insert_short(((java.lang.Short)value).shortValue());
	    if(type.equals("java.lang.Float")||type.equals("float"))
		any.insert_float(((java.lang.Float)value).floatValue());
	    if(type.equals("java.lang.Double")||type.equals("double"))
		any.insert_double(((java.lang.Double)value).doubleValue());
	    if(type.equals("[B"))
		org.omg.CORBA.OctetSeqHelper.insert(any,(byte[])value);
	    if(type.equals("[I"))
		org.omg.CORBA.LongSeqHelper.insert(any,(int[])value);
	    if(type.equals("[J"))
		org.omg.CORBA.LongLongSeqHelper.insert(any,(long[])value);
	    if(type.equals("[Z"))
		org.omg.CORBA.BooleanSeqHelper.insert(any,(boolean[])value);
	    if(type.equals("[S"))
		org.omg.CORBA.ShortSeqHelper.insert(any,(short[])value);
	    if(type.equals("[C"))
		org.omg.CORBA.CharSeqHelper.insert(any,(char[])value);
	    if(type.equals("[F"))
		org.omg.CORBA.FloatSeqHelper.insert(any,(float[])value);
	    if(type.equals("[D"))
		org.omg.CORBA.DoubleSeqHelper.insert(any,(double[])value);
	    if(type.equals("[Ljava.lang.String;"))
		org.omg.CORBA.StringSeqHelper.insert(any,(String[])value);
	    if(type.equals("org.omg.CORBA.Any"))
		any.insert_any((org.omg.CORBA.Any)value);
	    if(type.equals("org.omg.CORBA.Object"))
		any.insert_Object((org.omg.CORBA.Object)value);
	}catch(java.lang.Exception e){e.printStackTrace();return null;}
	return any;
    }
    public static byte[] makeIntByte(int nr){
	byte[] toRet=new byte[4];
	int i;

	for(i=0;i<4;i++){
	    nr=nr >> (i*8);
	    toRet[i]=(byte)(nr&0x000000FF);
	}
	return toRet;
    }

    public static int makeByteInt(byte[] b)
    {
	int toRet;
	int i;

	if(b.length!=4) return -1;

	toRet=0;

	for(i=3;i>=0;i--){
	    toRet=toRet<< 8;
	    toRet+=b[i];
	    if(b[i]<0)
		toRet+=256;
	}
	return toRet;
    }
    public static IOR get_ior(org.omg.CORBA.Object obj){
	return ((org.openorb.CORBA.Delegate)((org.omg.CORBA.portable.ObjectImpl)obj)._get_delegate()).ior();
    }

    public static IOR get_ior(org.omg.CORBA.Object[] obj){

	IOR iors[]=new IOR[obj.length],toRet;
	int i;
	for(i=0;i<obj.length;i++)
	    iors[i]=((org.openorb.CORBA.Delegate)((org.omg.CORBA.portable.ObjectImpl)obj[i])._get_delegate()).ior();
	toRet=merge_unique_iors(iors[i-1].type_id,iors);
	return toRet;
    }
 public static IOR merge_unique_iors(String type_id,IOR[] iors){
	TaggedProfile[] merged_profs;
	int nr_profs=0,i,j;

	for(i=0;i<iors.length;i++)
	    nr_profs+=iors[i].profiles.length;

	merged_profs=new TaggedProfile[nr_profs];

	nr_profs=0;

	for(i=0;i<iors.length;i++)
	    for(j=0;j<iors[i].profiles.length;j++){
		merged_profs[nr_profs]=iors[i].profiles[j];
		nr_profs++;
	    }
	return new IOR(type_id,merged_profs);
    }

  public static void trace(int moment_code,int retention_id,String client_id,long time,String oper_name,java.io.RandomAccessFile raf){
	if(raf==null) return;
	synchronized(raf){
	    try{
		raf.writeInt(moment_code);
		raf.writeInt(retention_id);
		raf.writeLong(time);
		raf.writeBytes(client_id+"\n");
		raf.writeBytes(oper_name+"\n");
	    }catch(java.lang.Exception e){e.printStackTrace(new java.io.PrintStream(System.out));}
	}
  }


       public static Hashtable[] a_minus_b_a_inters_b_b_minus_a(Hashtable a,Hashtable b){
	Hashtable three_sets[]=new Hashtable[3], b_copy=new Hashtable(),a_minus_b=new Hashtable(),a_inters_b=new Hashtable(),b_minus_a=new Hashtable();
	Set a_s;
	Iterator set_iter_a;
	Map.Entry elem_a;
	Vector elem_to_rem_b=new Vector();

	int i,l;

	a_s=a.entrySet();
	set_iter_a=a_s.iterator();
	b_copy.putAll(b);
	while(set_iter_a.hasNext()){
	    elem_a=(Map.Entry)set_iter_a.next();
	    if(!b_copy.containsKey(elem_a.getKey()))
		a_minus_b.put(elem_a.getKey(),elem_a.getValue());
	    else{
		a_inters_b.put(elem_a.getKey(),elem_a.getValue());
		elem_to_rem_b.addElement(elem_a.getKey());
	    }
	}
	l=elem_to_rem_b.size();
	for(i=0;i<l;i++)
	b_copy.remove(elem_to_rem_b.elementAt(i));
	b_minus_a.putAll(b_copy);
	three_sets[0]=a_minus_b;
	three_sets[1]=a_inters_b;
	three_sets[2]=b_minus_a;
	return three_sets;
    }


    public static long[][] a_minus_b_b_minus_a(long[] a,long[] b){
	long[] two_sets[]=new long[2][], a_minus_b,b_minus_a,b_copy;
	Vector a_minus_b_v=new Vector();
	int i,j,size_b_m_a;
	boolean found;
	if(a==null) {
	    two_sets[0]=new long[0];
	    if(b==null)
		two_sets[1]=new long[0];
	    else
		two_sets[1]=b;
	    return two_sets;
	}
	if(b==null) {
	    two_sets[0]=a;
	    two_sets[1]=new long[0];
	    return two_sets;
	}

	size_b_m_a=b.length;
	b_copy=new long[size_b_m_a];
	System.arraycopy(b,0,b_copy,0,size_b_m_a);
	for(i=0;i<a.length;i++){
	    found=false;
	    for(j=0;j<b_copy.length;j++)
		if(a[i]==b_copy[j]){
		    found=true;
		    break;
		}
	    if(!found)
		a_minus_b_v.addElement(new Long(a[i]));
	    else{
		b_copy[j]=Long.MIN_VALUE;
		size_b_m_a--;
	    }
	}
	b_minus_a=new long[size_b_m_a];
	j=0;
	for(i=0;i<b_copy.length;i++)
	if(b_copy[i]!=Long.MIN_VALUE){
	    b_minus_a[j]=b_copy[i];
	    j++;
	}
	a_minus_b=new long[a_minus_b_v.size()];
	for(i=0;i<a_minus_b.length;i++)
	a_minus_b[i]=((Long)a_minus_b_v.elementAt(i)).longValue();
	two_sets[0]=a_minus_b;
	two_sets[1]=b_minus_a;
	return two_sets;
    }
    public static Hashtable minus(Hashtable set_a, Hashtable set_b){
	if(set_b==null||set_b.size()==0) return set_a;
	if(set_a==null) return new java.util.Hashtable();
	Hashtable minus_set=new Hashtable();
	Set a_s=set_a.entrySet();
	Iterator set_iter_a=a_s.iterator();
	Map.Entry elem_a;
	while(set_iter_a.hasNext()){
	    elem_a=(Map.Entry)set_iter_a.next();
	    if(!set_b.containsKey(elem_a.getKey()))
		minus_set.put(elem_a.getKey(),elem_a.getValue());
	}
	return minus_set;
    }

    public static long[] minus(long[] a,long[] b){
	int i,j;
	boolean found;
	if(a==null) return new long[0];
	if(b==null||b.length==0) return a;
	Vector temp=new Vector();
	for(i=0;i<a.length;i++){
	    found=false;
	    for(j=0;j<b.length;j++){
		if(a[i]==b[j]){
		    found=true;
		    break;
		}
	    }
	    if(!found)
		temp.addElement(new Long(a[i]));
	}

	long[] ret=new long[temp.size()];
	for(i=0;i<ret.length;i++)
	ret[i]=((Long)temp.elementAt(i)).longValue();
	return ret;
    }

/** Method used in the FA-CORBA infrastructure when the outcome register of a witness has to be reduced, by removing the
* update records since the last state record, and replace them by one state record
* @param	reg the vector representing the register of the witness
*			k the position in the total order of requests of the request that was processed before sending the state
*/
    public static void prune_outcome_vector(java.util.Vector reg,int k){
	int i,l;
	universal.Outcome crt;
	java.util.Vector toRemove=new java.util.Vector();
	l=reg.size();
	for(i=0;i<l;i++){
	    crt=(universal.Outcome)reg.elementAt(i);
	    if(crt.after_n_req<k)
		toRemove.addElement(crt);
	}
	reg.removeAll(toRemove);
    }

/** Method that returns the element in the Outcome vector (used in FA-CORBA infrastructure) that corresponds to an update
* that happened after k number of requests processed
* Since the number of records in the vector is not the sane as the requests processed, in order to return the element "k", it
* is not possible to return the element on position k, but the element for which the field after_n_req is k
*/
    public static universal.Outcome elementAt(java.util.Vector reg,int k){
	int i,l;
	universal.Outcome crt;
	l=reg.size();
	for(i=0;i<l;i++){
	    crt=(universal.Outcome)reg.elementAt(i);
	    if(crt.after_n_req==k)
		return crt;
	}
	return null;
    }
}
