/**
 * Redistribution and use of this software and associated
 * documentation ("Software"), with or without modification, are
 * permitted provided that the following conditions are met:
 *
 * 1. Redistributions of source code must retain copyright statements
 *    and notices.  Redistributions must also contain a copy of this
 *    document.
 *
 * 2. Redistributions in binary form must reproduce the above
 *    copyright notice, this list of conditions and the following
 *    disclaimer in the documentation and/or other materials provided
 *    with the distribution.
 *
 * 3. The names "TRANSORG" or "EUTIST-AMI" must not be used to endorse or promote
 *    products derived from this Software without prior written
 *    permission of one of the parties involved in the TRANSORG project. For
 * 	  written permission, please contact diasz@ida.liu.se.
 *
 * 4. Products derived from this Software may not be called "TRANSORG"
 *    nor may "TRANSORG" appear in their names without prior written
 *    permission.
 *
 * 5. Due credit should be given to the TRANSORG Project
 *    (http://www.ida.liu.se/~rtslab/TRANSORG/).
 *
 * THIS SOFTWARE IS PROVIDED BY THE TRANSORG PROJECT CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESSED OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
 * THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A
 * PARTICULAR PURPOSE ARE DISCLAIMED.
 *
 * IN NO EVENT SHALL THE TRANSORG PROJECT CONTRIBUTORS
 * BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
 * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE
 * GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
 * CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
 * OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT
 * OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 * Copyright 2003 (C) TRANSORG Project Contributors All Rights Reserved.
 *
 * $Id: NRClientInterceptor.java,v 1.0  diasz Exp $
 *
 * Date         Author  Changes
 */

package universal;


/*
 * Author       : Isabelle Ravot
 * Date         : 01/08/02
 * Last changes : 01/08/02
 * Contact		: diasz@ida.liu.se
 */

/**
 *The client interceptor for the case  we don't replicate the server.
 */

public class NRClientInterceptor extends org.omg.CORBA.LocalObject implements org.omg.PortableInterceptor.ClientRequestInterceptor
{

    org.omg.PortableInterceptor.ORBInitInfo info;
    int ft_slot;

    org.omg.CORBA.ORB orb;
    String location;
    java.io.RandomAccessFile trace_file=null;


    public NRClientInterceptor(org.omg.PortableInterceptor.ORBInitInfo inf,int t_slot)
    {
	info = inf;
	ft_slot=t_slot;

	java.util.Properties pr=System.getProperties();
	orb=((org.openorb.PI.OpenORBInitInfo)info).orb();

	try{
	    location=java.net.InetAddress.getLocalHost().getHostName();
	}catch(Exception e){location="localhost";}

    }
    /* Extract the TAG_FT_GROUP component of the profile which contains the
       TAG_FT_PRIMARY component*/


    public void send_request(org.omg.PortableInterceptor.ClientRequestInfo ri)
	throws org.omg.PortableInterceptor.ForwardRequest
    {
	 System.out.println("the operation is : "+ri.operation());
	if((((ri.operation()).compareTo("replicas"))!=0)&&(((ri.operation()).compareTo("client"))!=0))
	    {


		/* add the service context to the request : retention_id,client_id
		 *,request_start_time.
		 */
		trace_file=(java.io.RandomAccessFile)((org.openorb.CORBA.ORB)orb).getFeature("trace_file");
		int retention_id;
		String client_id;
		long request_start_time;
		org.omg.IOP.CodecFactory codecFactory;
		org.omg.IOP.Encoding encoding;
		org.omg.IOP.Codec codec;
		org.omg.CORBA.Any any;
		retention_id=((org.openorb.net.ClientRequest)ri).retention_id();
		client_id=((org.openorb.net.ClientRequest)ri).client_id();
		universal.utils.Utils.trace(universal.utils.Utils.ENTER_SEND_REQUEST,retention_id,client_id,System.currentTimeMillis(),ri.operation(),trace_file);
		request_start_time=((org.openorb.net.ClientRequest)ri).request_start_time();
		System.out.println("Le retention_id est :"+retention_id);
		System.out.println("le client_id est : "+client_id);
		org.omg.IOP.ServiceContext serviceCtx_req = new org.omg.IOP.ServiceContext();
		serviceCtx_req.context_id = universal.Constants.NUM_Service_Context;
		universal.RequestServiceContext ctx_req=new universal.RequestServiceContext(request_start_time,retention_id,client_id);
		try
		    {
			codecFactory = info.codec_factory();
			encoding = new org.omg.IOP.Encoding(org.omg.IOP.ENCODING_CDR_ENCAPS.value,(byte)1,(byte)2);
			codec = codecFactory.create_codec(encoding);
			any = orb.create_any();
			universal.RequestServiceContextHelper.insert(any,ctx_req);
			serviceCtx_req.context_data = codec.encode_value(any);

		    }
		catch (Exception e){System.out.println("Exception in clientInterceptor");e.printStackTrace(new java.io.PrintStream(System.out));}

		ri.add_request_service_context(serviceCtx_req,true);
		universal.utils.Utils.trace(universal.utils.Utils.EXIT_SEND_REQUEST,retention_id,client_id,System.currentTimeMillis(),ri.operation(),trace_file);



	    }



    }

    public void send_poll(org.omg.PortableInterceptor.ClientRequestInfo ri)
    {
	System.out.println("essaisend_poll");
    }

    public void receive_reply(org.omg.PortableInterceptor.ClientRequestInfo ri)
    {

	System.out.println("Receives a reply for the operation : " + ri.operation() );

	trace_file=(java.io.RandomAccessFile)((org.openorb.CORBA.ORB)orb).getFeature("trace_file");
	universal.utils.Utils.trace(universal.utils.Utils.EXIT_RECEIVE_REPLY,((org.openorb.net.ClientRequest)ri).retention_id(),((org.openorb.net.ClientRequest)ri).client_id(),System.currentTimeMillis(),ri.operation(),trace_file);
    }
    public void receive_exception(org.omg.PortableInterceptor.ClientRequestInfo ri)
	throws org.omg.PortableInterceptor.ForwardRequest
    {
	System.out.println("essai receive exeption");
    }

    public void receive_other(org.omg.PortableInterceptor.ClientRequestInfo ri)
	throws org.omg.PortableInterceptor.ForwardRequest
    {
	System.out.println("essaireceive other");
    }

    public String name()
    {
	return "ClientInterceptor";
    }

    public void destroy()
    {
    }
}
